<?php
include_once("../phpsrc/Common.php");
include_once("../phpsrc/baseclass/XMLAPICommand.class.php");
include_once("../phpsrc/common_smarty.php");
include_once("../phpsrc/baseclass/User.class.php");
include_once("../phpsrc/baseclass/BGAJob.class.php");
include_once("../phpsrc/baseclass/DataAccess.class.php");
include_once("../phpsrc/baseclass/XMLDataAccess.class.php");
include_once("../phpsrc/baseclass/BGAJobDataAccess.class.php");
include_once("../phpsrc/baseclass/UserDataAccess.class.php");
include_once("../phpsrc/authorization.php");
header("Content-type: text/xml");//xml header

//no cache http header response
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Cache-control: private");
header("Pragma: no-cache");

//xml header
echo '<?xml version="1.0" encoding="UTF-8" ?>'; 

include_once("../phpsrc/baseclass/XmlHandler.class.php");
include_once("../phpsrc/baseclass/DgXmlHandler.class.php");
include_once("../phpsrc/baseclass/EncXmlHandler.class.php");
include_once("../phpsrc/baseclass/ExpXmlHandler.class.php");
include_once("../phpsrc/baseclass/HdXmlHandler.class.php");
include_once("../phpsrc/baseclass/LdXmlHandler.class.php");
include_once("../phpsrc/baseclass/PMXmlHandler.class.php");

include_once("../phpsrc/baseclass/XMLAPICommand.class.php");
include_once("../phpsrc/baseclass/RequestSender.class.php");
include_once("../phpsrc/baseclass/BaseMultiRequestSender.class.php");
include_once("../phpsrc/baseclass/BaseSingleRequestSender.class.php");

include_once("../phpsrc/baseclass/BaseFactory.class.php");

include_once("../phpsrc/baseclass/BaseData.class.php");
include_once("../phpsrc/baseclass/SASAddress.class.php");
include_once("../phpsrc/baseclass/Device.class.php");
include_once("../phpsrc/baseclass/HBA.class.php");
include_once("../phpsrc/baseclass/HBABase.class.php");
include_once("../phpsrc/baseclass/HBAList.class.php");
include_once("../phpsrc/baseclass/HBADetail.class.php");
include_once("../phpsrc/baseclass/ExpanderBase.class.php");
include_once("../phpsrc/baseclass/PMBase.class.php");
include_once("../phpsrc/baseclass/HdBase.class.php");
include_once("../phpsrc/baseclass/LD.class.php");
include_once("../phpsrc/baseclass/LdBase.class.php");
include_once("../phpsrc/baseclass/LdDetail.class.php");
include_once("../phpsrc/baseclass/DG.class.php");
include_once("../phpsrc/baseclass/DgBase.class.php");
include_once("../phpsrc/baseclass/DgList.class.php");
include_once("../phpsrc/action/UserAction.class.php");
include_once("../phpsrc/action/ActionOnDG.class.php");
include_once("../phpsrc/action/XMLRet.class.php");

include_once("../phpsrc/Util.php");
include_once("../phpsrc/localization.php");

$cmdName = getRequestPara("cmdName");

$action = null;

//choose action to run
switch ($cmdName)
{
	case APICmd::flashBios:
		include_once("../phpsrc/action/ActionFlashBios.class.php");
		$action = new ActionFlashBios();
		break;
	case APICmd::ldondgbgaControl:
		include_once("../phpsrc/action/ActionLdOnDgBAGControl.class.php");
		$action = new ActionLdOnDgBAGControl();
		break;
	case APICmd::saveDgConfig:
		include_once("../phpsrc/action/ActionSaveDGConfig.class.php");
		$action = new ActionSaveDGConfig();
		break;
	case APICmd::createDGNext:
		include_once("../phpsrc/action/ActionCreateDG.class.php");
		$action = new ActionCreateDG();
		break;
	case APICmd::createDGSubmit:
		include_once("../phpsrc/action/ActionCreateDG.class.php");
		$action = new ActionCreateDG();
		break;
	case APICmd::deleteDG:
		include_once("../phpsrc/action/ActionDeleteDG.class.php");
		$action = new ActionDeleteDG();
		break;
	case APICmd::migrateDG:
		include_once("../phpsrc/action/ActionMigrateDG.class.php");
		$action = new ActionMigrateDG();
		break;
	case APICmd::rebuildDG:
		include_once("../phpsrc/action/ActionRebuildDG.class.php");
		$action = new ActionRebuildDG();
		break;
	case APICmd::saveDgConfig:
		include_once("../phpsrc/action/ActionSaveDGConfig.class.php");
		$action = new ActionSaveDGConfig();
		break;
		 
	case APICmd::dgbgaControl:
		include_once("../phpsrc/action/ActionDgBGAControl.class.php");
		$action = new ActionDgBGAControl();
		break;
	
	case APICmd::createVdOnDg:
		include_once("../phpsrc/action/ActionCreateVdOnDg.class.php");
		$action = new ActionCreateVdOnDg();
		break;
	case APICmd::initVdOnDg :
		include_once("../phpsrc/action/ActionInitVdOndg.class.php");
		$action = new ActionInitVdOnDg();
		break;
	case APICmd::checkVdOnDg:
		include_once("../phpsrc/action/ActionCheckVdOnDg.class.php");
		$action = new ActionCheckVdOnDg();
		break;
	case APICmd::deleteVdOnDg:
		include_once("../phpsrc/action/ActionDeleteVdOnDg.class.php");
		$action = new ActionDeleteVdOnDg();
		break;
	case APICmd::saveVdOnDg:
		include_once("../phpsrc/action/ActionSaveVdOnDgConfig.class.php");
		$action = new ActionSaveVdOnDgConfig();
		break;
		
	case APICmd::initLD :
		include_once("../phpsrc/action/ActionInitLD.class.php");
		$action = new ActionInitLD();
		break;
	case APICmd::checkLD:
		include_once("../phpsrc/action/ActionCheckLD.class.php");
		$action = new ActionCheckLD();
		break;
	case APICmd::quickCreateVD:
		include_once("../phpsrc/action/ActionQuickCreateVD.class.php");
		$action = new ActionQuickCreateVD();
		break;
	case APICmd::createLD:
		include_once("../phpsrc/action/ActionCreateLD.class.php");
		$action = new ActionCreateLD();
		break;
	case APICmd::deleteLD:
		include_once("../phpsrc/action/ActionDeleteLD.class.php");
		$action = new ActionDeleteLD();
		break;
	case APICmd::bgaControl:
		include_once("../phpsrc/action/ActionBGAControl.class.php");
		$action = new ActionBGAControl();
		break;
	case APICmd::migrateLD:
		include_once("../phpsrc/action/ActionMigrateLD.class.php");
		$action = new ActionMigrateLD();
		break;
	case APICmd::rebuildLD:
		include_once("../phpsrc/action/ActionRebuildLD.class.php");
		$action = new ActionRebuildLD();
		break;
	case APICmd::saveLDConfig:
		include_once("../phpsrc/action/ActionSaveLDConfig.class.php");
		$action = new ActionSaveLDConfig();
		break;
	case APICmd::importLD:
		include_once("../phpsrc/action/ActionImportLD.class.php");
		$action = new ActionImportLD();
		break;
	case APICmd::saveHDConfig:
		include_once("../phpsrc/action/ActionSaveHDConfig.class.php");
		$action = new ActionSaveHDConfig();
		break;
	case APICmd::setHDStatus:
		include_once("../phpsrc/action/ActionSetHdStatus.class.php");
		$action = new ActionSetHdStatus();
		break;
	case APICmd::saveLEDConfig:
		include_once("../phpsrc/action/ActionSaveLEDConfig.class.php");
		$action = new ActionSaveLEDConfig();
		break;
	case APICmd::saveENCElementConfig:
		include_once("../phpsrc/action/ActionSaveENCElementConfig.class.php");
		$action = new ActionSaveENCElementConfig();
		break;
	case APICmd::saveHBAConfig:
		include_once("../phpsrc/action/ActionSaveHBAConfig.class.php");
		$action = new ActionSaveHBAConfig();
		break;
	case APICmd::clearSP:
		include_once("../phpsrc/action/ActionClearSpare.class.php");
		$action = new ActionClearSpare();
		break;
	case APICmd::setGlobalSP:
		include_once("../phpsrc/action/ActionSetGlobalSpare.class.php");
		$action = new ActionSetGlobalSpare();
		break;
	case APICmd::setLDSP:
		include_once("../phpsrc/action/ActionSetLDSpare.class.php");
		$action = new ActionSetLDSpare();
		break;
	case APICmd::getEventGrid:
		include_once("../phpsrc/action/GetEventsInfo.class.php");
		$action = new GetEventsInfo();
		break;
	case APICmd::getMigratedLDSize :
		include_once("../phpsrc/action/GetMigratedLDSize.class.php");
		$action = new GetMigratedLDSize();
		break;
	case APICmd::getMigratedDgSize :
		include_once("../phpsrc/action/GetMigratedDgSize.class.php");
		$action = new GetMigratedDgSize();
		break;
	case APICmd::clearEvents :
		include_once("../phpsrc/action/ActionClearEvents.class.php");
		$action = new ActionClearEvents();
		break;
	case APICmd::testMailSetting :
		include_once("../phpsrc/action/ActionTestMailSetting.class.php");
		$action = new ActionTestMailSetting();
		break;
	case APICmd::mediaPatrolPD :
		include_once("../phpsrc/action/ActionMediaPatrolPD.class.php");
		$action = new ActionMediaPatrolPD();
		break;
	case APICmd::pdbgaControl :
		include_once("../phpsrc/action/ActionHdBgaControl.class.php");
		$action = new ActionHdBgaControl();
		break;
	case APICmd::dataScrubPd :
		include_once("../phpsrc/action/ActionDataScrubHd.class.php");
		$action = new ActionDataScrubHd();
		break;
	case APICmd::setDedicatedSP :
		include_once("../phpsrc/action/ActionSetDedicatedSpare.class.php");
		$action = new ActionSetDedicatedSpare();
		break;
	case APICmd::wipePD :
		include_once("../phpsrc/action/ActionWipePD.class.php");
		$action = new ActionWipePD();
		break;
	case APICmd::saveBBUConfig:
		include_once("../phpsrc/action/ActionSaveBBUConfig.class.php");
		$action = new ActionSaveBBUConfig();
		break;
	case APICmd::saveBBUSchedule:
		include_once("../phpsrc/action/ActionBBUSchedule.class.php");
		$action = new ActionBBUSchedule();
		break;
        case APICmd::muteAdapter:
		include_once("../phpsrc/action/ActionAdapterMute.class.php");
		$action = new ActionAdapterMute();
		break;
	default:
		break;
}

if ($action) {
	$action->smartyAssign($smarty);
	$action->displayResultXML();
}
?>
