<?php	
define("UNIT_K",1024);
define("UNIT_KILO",1024);
define("GET_ALL",255);

define("INVALID_ID",0xFF); // for old driver
define("UNDEFINED_ID",0xFFFF);
//disable mail support
define("MAIL_SUPPORT",1);
/*
// code for disable mail support
if (file_exists('../phpsrc/SupportMail.php')) {
	include_once("../phpsrc/SupportMail.php");
}
if (file_exists('../phpsrc/NotSupportMail.php')) {
	include_once("../phpsrc/NotSupportMail.php");
}
*/
class RebuildParam
{
	const REBUILD_VD = 1;
	const REBUILD_DG = 2;
}

class LEDStatus
{
	const SGPIO_LED_LOW = 0;
	/*const SGPIO_LED_HIGH = 1;
	const SGPIO_LED_BLINK_A = 2;
	const SGPIO_LED_BLINK_INVRT_A = 3; 
	const SGPIO_LED_BLINK_SOF = 4; 
	const SGPIO_LED_BLINK_EOF = 5;
	const SGPIO_LED_BLINK_B = 6;
	const SGPIO_LED_BLINK_INVRT_B = 7;*/
	
	const LED_ON_IMG = "ledon.gif";
	const LED_OFF_IMG = "ledoff.gif";
	const LED_BLINK_IMG = "ledblink.gif";
	
	public static function GetLEDImg ($StatusInt)
	{
		switch ($StatusInt)
		{
			case self::SGPIO_LED_LOW:
				return self::LED_OFF_IMG;
			default:
				return self::LED_ON_IMG;
		}
	}
}

class LEDType
{
	const SGPIO_LED_ACTIVITY = 0;
	const SGPIO_LED_LOCATE = 1;
	const SGPIO_LED_ERROR = 2;
	const SGPIO_LED_ALL = 0xff; 
}

class ENCStatus
{
	const STATUS_NOT_EXIST = 0;
	const STATUS_NOT_EXIST_STR = "Not exist";
	
	const ENC_STATUS_OK = 1;
	const ENC_STATUS_OK_STR = "OK";
	
	const ENC_STATUS_UNSTABLE = 2;
	const ENC_STATUS_UNSTABLE_STR = "Unstable";
	
	public static function GetStatusStr($statusInt)
	{
		switch ($statusInt)
		{
			case self::ENC_STATUS_OK :
				return self::ENC_STATUS_OK_STR ;
			case self::ENC_STATUS_UNSTABLE :
				return self::ENC_STATUS_UNSTABLE_STR ;
			default:
				return "Unknown"; // (" . $statusInt . ")
		}
	}
}

class ENCType
{
	const ENC_TYPE_UNKNOW = 0;
	const ENC_TYPE_UNKNOW_STR = "Unknown";
	
	const ENC_TYPE_SATA = 1;
	const ENC_TYPE_SATA_STR = "SATA Enclosure";
	
	const ENC_TYPE_SAS = 2;
	const ENC_TYPE_SAS_STR = "SAS Enclosure";
	
	public static function GetTypeStr($typeInt)
	{
		switch ($typeInt)
		{
			case self::ENC_TYPE_SAS :
				return self::ENC_TYPE_SAS_STR ;
			case self::ENC_TYPE_SATA :
				return self::ENC_TYPE_SATA_STR ;
			default:
				return "Unknown (" . $typeInt . ")";
		}
	}
}

class ENCElementStatus
{
	const SES2_ELEMENT_STATUS_UNSUPPORT = 0;
	const SES2_ELEMENT_STATUS_UNSUPPORT_STR = "Unsupport";
	const SES2_ELEMENT_STATUS_OK = 1;
	const SES2_ELEMENT_STATUS_OK_STR = "OK";
	const SES2_ELEMENT_STATUS_CRITICAL = 2;
	const SES2_ELEMENT_STATUS_CRITICAL_STR = "Critical";
	const SES2_ELEMENT_STATUS_NONCRITICAL = 3;
	const SES2_ELEMENT_STATUS_NONCRITICAL_STR = "Not critical";
	const SES2_ELEMENT_STATUS_UNRECOVERABLE = 4;
	const SES2_ELEMENT_STATUS_UNRECOVERABLE_STR = "Unrecoverable";
	const SES2_ELEMENT_STATUS_NOTINSTALL = 5;
	const SES2_ELEMENT_STATUS_NOTINSTALL_STR = "Not installed";
	const SES2_ELEMENT_STATUS_UNKNOWN = 6;
	const SES2_ELEMENT_STATUS_UNKNOWN_STR = "Unknown";
	const SES2_ELEMENT_STATUS_NOTAVAILABLE = 7;
	const SES2_ELEMENT_STATUS_NOTAVAILABLE_STR = "Not available";
	const SES2_ELEMENT_STATUS_ACCESSALLOWED = 8;
	const SES2_ELEMENT_STATUS_ACCESSALLOWED_STR = "Access allowed";
	
	public static function getENCElementStatus($statusInt)
	{
		switch ($statusInt)
		{
			case self::SES2_ELEMENT_STATUS_OK ;
				return self::SES2_ELEMENT_STATUS_OK_STR;
			case self::SES2_ELEMENT_STATUS_ACCESSALLOWED :
				return self::SES2_ELEMENT_STATUS_ACCESSALLOWED_STR ;
			case self::SES2_ELEMENT_STATUS_CRITICAL :
				return self::SES2_ELEMENT_STATUS_CRITICAL_STR ;
			case self::SES2_ELEMENT_STATUS_NONCRITICAL :
				return self::SES2_ELEMENT_STATUS_NONCRITICAL_STR ;
			case self::SES2_ELEMENT_STATUS_NOTAVAILABLE :
				return self::SES2_ELEMENT_STATUS_NOTAVAILABLE_STR ;
			case self::SES2_ELEMENT_STATUS_NOTINSTALL :
				return self::SES2_ELEMENT_STATUS_NOTINSTALL_STR ;
			case self::SES2_ELEMENT_STATUS_UNRECOVERABLE :
				return self::SES2_ELEMENT_STATUS_UNRECOVERABLE_STR ;
			case self::SES2_ELEMENT_STATUS_UNSUPPORT :
				return self::SES2_ELEMENT_STATUS_UNSUPPORT_STR ;
			default:
				return self::SES2_ELEMENT_STATUS_UNKNOWN_STR ." (" . $statusInt . ")";
		}		
	}
}

//belows not localized
class ENCElementWarnBit
{
	const ENC_POWERSUPPLY_TEMPWARN = 4;
	const ENC_POWERSUPPLY_TEMPWARN_STR = "Over temperature warning";
	const ENC_POWERSUPPLY_HOTSWAP = 128;
	const ENC_POWERSUPPLY_HOTSWAP_STR = "Hot swappable";
	const ENC_POWERSUPPLY_DCOVERCURRENT = 3;
	const ENC_POWERSUPPLY_DCOVERCURRENT_STR = "DC over current";
	const ENC_POWERSUPPLY_DCOVER = 2;
	const ENC_POWERSUPPLY_DCOVER_STR = "DC over voltage";
	const ENC_POWERSUPPLY_DCUNDER = 1;
	const ENC_POWERSUPPLY_DCUNDER_STR = "DC under voltage";
	
	const ENC_TEMPSENSOR_UTWARN = 1;
	const ENC_TEMPSENSOR_UTWARN_STR = "Under temperature warning";
	const ENC_TEMPSENSOR_UTFAIL = 2;
	const ENC_TEMPSENSOR_UTFAIL_STR = "Under temperature failure";
	const ENC_TEMPSENSOR_OTWARN = 4;
	const ENC_TEMPSENSOR_OTWARN_STR = "Over temperature warning";
	const ENC_TEMPSENSOR_OTFAIL = 8;
	const ENC_TEMPSENSOR_OTFAIL_STR = "Over temperature failure";
	
	const ENC_VOLTAGESENSOR_WARNOVER = 8;
	const ENC_VOLTAGESENSOR_WARNOVER_STR = "Over voltage warning";
	const ENC_VOLTAGESENSOR_WARNUNDER = 4;
	const ENC_VOLTAGESENSOR_WARNUNDER_STR = "Under voltage warning";
	const ENC_VOLTAGESENSOR_CRITOVER = 2;
	const ENC_VOLTAGESENSOR_CRITOVER_STR = "Critical over voltage";
	const ENC_VOLTAGESENSOR_CRITUNDER = 1;	
	const ENC_VOLTAGESENSOR_CRITUNDER_STR = "Critical under voltage";	
	
	public static function getENCElementWarnBit($typeInt, $warnInt)
	{
		$RetVal = "No warning";
		switch ($typeInt)
		{
			case ENCElementType::ENC_ELEMENTTYPE_POWERSUPPLY :
				if ($warnInt & self::ENC_POWERSUPPLY_HOTSWAP)
				{
					$RetVal = self::ENC_POWERSUPPLY_TEMPWARN_STR ;
				} elseif ($warnInt & self::ENC_POWERSUPPLY_TEMPWARN)
				{
					$RetVal = self::ENC_POWERSUPPLY_TEMPWARN_STR ;
				} elseif ($warnInt & self::ENC_POWERSUPPLY_DCOVER)
				{
					$RetVal = self::ENC_POWERSUPPLY_DCOVER_STR ;
				} elseif ($warnInt & self::ENC_POWERSUPPLY_DCUNDER)
				{
					$RetVal = self::ENC_POWERSUPPLY_DCUNDER_STR ;
				}
			case ENCElementType::ENC_ELEMENTTYPE_COOLING :
				break;
			case ENCElementType::ENC_ELEMENTTYPE_TEMPERATURE :
				if ($warnInt & self::ENC_TEMPSENSOR_OTFAIL)
					$RetVal = self::ENC_TEMPSENSOR_OTFAIL_STR ;
				elseif ($warnInt & self::ENC_TEMPSENSOR_OTWARN)
					$RetVal = self::ENC_TEMPSENSOR_OTWARN_STR ;
				elseif ($warnInt & self::ENC_TEMPSENSOR_UTFAIL)
					$RetVal = self::ENC_TEMPSENSOR_UTFAIL_STR ;
				elseif ($warnInt & self::ENC_TEMPSENSOR_UTWARN)
					$RetVal = self::ENC_TEMPSENSOR_UTWARN_STR ;
		}
		return $RetVal;
	}
}

class ENCFan
{
	const FANSTOP = 0;
	const FANSTOP_STR = "Stop";
	const FANLOWEST = 1;
	const FANLOWEST_STR = "At lowest speed";
	const FANLOWER = 2;
	const FANLOWER_STR = "At lower speed";
	const FANLOW = 3;
	const FANLOW_STR = "At low speed";
	const FANNORMAL = 4;
	const FANNORMAL_STR = "At normal speed";
	const FANHIGH = 5;
	const FANHIGH_STR = "At high speed";
	const FANHIGHER = 6;
	const FANHIGHER_STR = "At higher speed";
	const FANHIGHEST = 7;
	const FANHIGHEST_STR = "At highest speed";
	
	public static function GetFanSpeedLevel($speed) {
		switch ($speed) {
			case self::FANSTOP :
				return self::FANSTOP_STR ;
			case self::FANLOWEST :
				return self::FANLOWEST_STR ;
			case self::FANLOWER :
				return self::FANLOWER_STR ;
			case self::FANLOW :
				return self::FANLOW_STR ;
			case self::FANNORMAL :
				return self::FANNORMAL_STR ;
			case self::FANHIGH :
				return self::FANHIGH_STR ;
			case self::FANHIGHER :
				return self::FANHIGHER_STR ;
			case self::FANHIGHEST :
				return self::FANHIGHEST_STR ;
			default:
				break;
		}
	}
}
class ENCElementImg
{
	const POWER_OK_IMG = "power.gif";
	const POWER_WARN_IMG = "power_warn.gif";
	const POWER_CRITICAL_IMG = "power_critical.gif";
	const POWER_DISABLE_IMG = "power_disable.gif";
	
	const ENC_COOLING_IMG = "fanon.gif";
	const ENC_COOLING_STOP_IMG = "fanoff.gif";
	
	const ENC_TPR_IMG = "tpr.gif";
	const ENC_VOL_IMG = "vol.gif";
	
	public static function GetPowerImg($status)
	{
		switch ($status)
		{
			case ENCElementStatus::SES2_ELEMENT_STATUS_CRITICAL :
				return self::POWER_CRITICAL_IMG ;
			case ENCElementStatus::SES2_ELEMENT_STATUS_OK :
				return self::POWER_OK_IMG ;
			default :
				return self::POWER_CRITICAL_IMG ;
		}
	}
	
	public static function GetFanImg($status)
	{
		if (($status != ENCElementStatus::SES2_ELEMENT_STATUS_OK 
		     && $status != ENCElementStatus::SES2_ELEMENT_STATUS_CRITICAL
		     && $status != ENCElementStatus::SES2_ELEMENT_STATUS_NONCRITICAL 
		     && $status != ENCElementStatus::SES2_ELEMENT_STATUS_ACCESSALLOWED) 
		     )
		{
			return self::ENC_COOLING_STOP_IMG ;
		} else {
			return self::ENC_COOLING_IMG ;
		}
	}
	
}

class ENCElementType
{
	const ENCUNKNOW_STR = "Unknown";
	const ENC_ELEMENTTYPE_UNKNOWN = 0;
	
	const POWERSUPPLY_STR = "Power";
	const ENC_ELEMENTTYPE_POWERSUPPLY = 2;
	
	const COOLING_STR = "Fan";
	const ENC_ELEMENTTYPE_COOLING = 3;
	
	const TEMPERATURE_STR = "Temperature sensor";
	const ENC_ELEMENTTYPE_TEMPERATURE = 4;
	
	const DOORLOCK_STR = "DoorLock";
	const ENC_ELEMENTTYPE_DOORLOCK = 5;
	
	const AUDIBLEALARM_STR = "Alarm";
	const ENC_ELEMENTTYPE_AUDIBLEALARM = 6;
	
	const DISPLAY_STR = "Display";
	const ENC_ELEMENTTYPE_DISPLAY = 12;
	
	const VOLTAGESENSOR_STR = "Voltage sensor";
	const ENC_ELEMENTTYPE_VOLTAGESENSOR = 18;
	
	public static function GetTypeStr($typeInt)
	{
		switch ($typeInt)
		{
			case self::ENC_ELEMENTTYPE_POWERSUPPLY :
				return self::POWERSUPPLY_STR ;
			case self::ENC_ELEMENTTYPE_COOLING :
				return self::COOLING_STR ;
			case self::ENC_ELEMENTTYPE_TEMPERATURE :
				return self::TEMPERATURE_STR ;
			case self::ENC_ELEMENTTYPE_VOLTAGESENSOR :
				return self::VOLTAGESENSOR_STR ;
			default:
				return "Unknown (" . $typeInt . ")";
		}
	}
}

class RAIDMode
{
	const RAID0 = "RAID 0";
	const LD_MODE_RAID0 = 0;
	
	const RAID1 = "RAID 1";
	const LD_MODE_RAID1 = 0x1;
	
	const RAID1E = "RAID 1E";
	const LD_MODE_RAID1E = 0x11;
	
	const RAID5 = "RAID 5";
	const LD_MODE_RAID5 = 0x5;
	
	const RAID6 = "RAID 6";
	const LD_MODE_RAID6 = 0x6;
	
	const JBOD = "JBOD";
	const LD_MODE_JBOD = 0x0f;
	
	const RAID10 = "RAID 10";
	const LD_MODE_RAID10 = 0x10;
	
	const RAID50 = "RAID 50";
	const LD_MODE_RAID50 = 0x50;
	
	const RAID60 = "RAID 60";
	const LD_MODE_RAID60 = 0x60;
	
	public static function GetRAIDModeStr($raidMode)
	{
		switch ($raidMode)
		{
			case self::LD_MODE_RAID0 : 
				return self::RAID0;
			case self::LD_MODE_RAID1 : 
				return self::RAID1;
			case self::LD_MODE_RAID1E : 
				return self::RAID1E;
			case self::LD_MODE_RAID5 : 
				return self::RAID5;
			case self::LD_MODE_RAID6 : 
				return self::RAID6;
			case self::LD_MODE_JBOD : 
				return self::JBOD;
			case self::LD_MODE_RAID10 : 
				return self::RAID10;
			case self::LD_MODE_RAID50 : 
				return self::RAID50;
			case self::LD_MODE_RAID60 : 
				return self::RAID60;
			default:
				return "Unknown (" . $raidMode . ")";
		}
	}
}

class DGStatus
{
	const DG_STATUS_FUNCTIONAL = 0;
	const DG_STATUS_FUNCTIONAL_STR = "Functional";
	const DG_STATUS_PD_MISSING = 1;
	const DG_STATUS_PD_MISSING_STR = "PD Missing";
	
	const DG_IMG_FUNCTIONAL = "Array_Online.gif";
	const DG_IMG_PD_Missing = "Array_Degrade.gif";
	//const DG_IMG_Offline = "Array_Offline.gif";
	//const DG_IMG_Partiallyoptimal = "Array_Partiallyoptimal.gif";
	//const DG_IMG_Foreign = "Array_Foreign.gif";
	
	public static function getDGImg($StatusInt)
	{
		$RetStr = "";
		switch ($StatusInt)
		{
			case self::DG_STATUS_FUNCTIONAL :
				$RetStr = self::DG_IMG_FUNCTIONAL ;
				break;
			case self::DG_STATUS_PD_MISSING  :
				$RetStr = self::DG_IMG_PD_Missing ;
				break;
			default :
				$RetStr = self::DG_IMG_FUNCTIONAL ;
				break;
		}
		return $RetStr;
	}
	
	
	public static function getDGStatusStr($StatusInt)
	{
		$RetStr = "";
		switch ($StatusInt)
		{
			case DGStatus::DG_STATUS_FUNCTIONAL  :
				$RetStr = DGStatus::DG_STATUS_FUNCTIONAL_STR ;
				break;
			case DGStatus::DG_STATUS_PD_MISSING  :
				$RetStr = DGStatus::DG_STATUS_PD_MISSING_STR ;
				break;
			default :
				$RetStr = "Unknown";
				break;
		}
		return $RetStr;
	}
	
	
}

class LDStatus
{
	const LD_STATUS_FUNCTIONAL = 0;
	const LD_STATUS_FUNCTIONAL_STR = "Functional";
	const LD_STATUS_DEGRADED = 1;
	const LD_STATUS_DEGRADED_STR = "Degraded";
	const LD_STATUS_DELETED = 2;
	const LD_STATUS_DELETED_STR = "Deleted";
	const LD_STATUS_MISSING = 3;
	const LD_STATUS_MISSING_STR = "Missing";
	const LD_STATUS_OFFLINE = 4;
	const LD_STATUS_OFFLINE_STR = "Offline";
	const LD_STATUS_PARTIALLYOPTIMAL = 5;
	const LD_STATUS_PARTIALLYOPTIMAL_STR = "Partial Optimal";
	const LD_STATUS_FOREIGN = 6;
	const LD_STATUS_FOREIGN_STR = "Foreign";
	const LD_STATUS_IMPORTABLE = 7;
	const LD_STATUS_IMPORTABLE_STR = "Importable Foreign";
	const LD_STATUS_NOT_IMPORTABLE = 8;
	const LD_STATUS_NOT_IMPORTABLE_STR = "Not Importable Foreign";
	//const LD_STATUS_MIGRATION = 8;
	//const LD_STATUS_MIGRATION_STR = "Migrating";
	//const LD_STATUS_INVALID = 0xff;
	//const LD_STATUS_INVALID_STR = 0xff;
	
	const LD_IMG_Online = "RAID_online.gif";
	const LD_IMG_Online_Bga = "RAID_online_bga.gif";
	const LD_IMG_Degrade = "RAID_degrade.gif";
	const LD_IMG_Degrade_Bga = "RAID_degrade_bga.gif";
	const LD_IMG_Offline = "RAID_offline.gif";
	const LD_IMG_Partiallyoptimal = "RAID_partiallyoptimal.gif";
	const LD_IMG_Partiallyoptimal_Bga = "RAID_partiallyoptimal_bga.gif";
	const LD_IMG_Foreign = "RAID_foreign.gif";
	
	public static function getLDImg($StatusInt, $BGAStatusInt=0)
	{
		$RetStr = "";
		switch ($StatusInt)
		{
			case self::LD_STATUS_FUNCTIONAL :
				if ($BGAStatusInt != LdBgaState::LD_BGA_STATE_NONE)
					$RetStr = self::LD_IMG_Online_Bga ;
				else
					$RetStr = self::LD_IMG_Online ;
				break;
			case self::LD_STATUS_DEGRADED  :
				if ($BGAStatusInt != LdBgaState::LD_BGA_STATE_NONE)
					$RetStr = self::LD_IMG_Degrade_Bga ;
				else
					$RetStr = self::LD_IMG_Degrade ;
				break;
			case self::LD_STATUS_OFFLINE :
				$RetStr = self::LD_IMG_Offline;
				break;
			case self::LD_STATUS_PARTIALLYOPTIMAL :
				if ($BGAStatusInt != LdBgaState::LD_BGA_STATE_NONE)
					$RetStr = self::LD_IMG_Partiallyoptimal_Bga ;
				else
					$RetStr = self::LD_IMG_Partiallyoptimal;
				break;
			case self::LD_STATUS_FOREIGN :
			case self::LD_STATUS_IMPORTABLE :
			case self::LD_STATUS_NOT_IMPORTABLE :
				$RetStr = self::LD_IMG_Foreign;
				break;
			//case self::LD_STATUS_MIGRATION :
			//	$RetStr = self::LD_IMG_Online_Bga ;
				//break;
			default :
				$RetStr = self::LD_STATUS_FOREIGN ;
				break;
		}
		return $RetStr;
	}
	
	
	public static function getLDStatusStr($StatusInt)
	{
		$RetStr = "";
		switch ($StatusInt)
		{
			case self::LD_STATUS_FUNCTIONAL :
				$RetStr = self::LD_STATUS_FUNCTIONAL_STR;
				break;
			case self::LD_STATUS_DEGRADED  :
				$RetStr = self::LD_STATUS_DEGRADED_STR;
				break;
			case self::LD_STATUS_DELETED  :
				$RetStr = self::LD_STATUS_DELETED_STR;
				break;
			case self::LD_STATUS_MISSING :
				$RetStr = self::LD_STATUS_MISSING_STR;
				break;
			case self::LD_STATUS_OFFLINE :
				$RetStr = self::LD_STATUS_OFFLINE_STR;
				break;
			case self::LD_STATUS_PARTIALLYOPTIMAL :
				$RetStr = self::LD_STATUS_PARTIALLYOPTIMAL_STR;
				break;
			case self::LD_STATUS_FOREIGN :
				$RetStr = self::LD_STATUS_FOREIGN_STR;
				break;
			case self::LD_STATUS_IMPORTABLE :
				$RetStr = self::LD_STATUS_IMPORTABLE_STR ;
				break;
			case self::LD_STATUS_NOT_IMPORTABLE :
				$RetStr = self::LD_STATUS_NOT_IMPORTABLE_STR ;
				break;
		/*	case self::LD_STATUS_MIGRATION :
				$RetStr = self::LD_STATUS_MIGRATION_STR;*/
				break;
			default :
				$RetStr = "Unknown";
				break;
		}
		return $RetStr;
	}
}

class LdBgaStatus
{
	const LD_BGA_NONE = 0;
	const LD_BGA_NONE_STR = "None";
	const LD_BGA_REBUILD = 1;
	const LD_BGA_REBUILD_STR = "Rebuild";
	const LD_BGA_CONSISTENCY_FIX = 2;
	const LD_BGA_CONSISTENCY_FIX_STR = "Consistency Fix";
	const LD_BGA_CONSISTENCY_CHECK = 4;
	const LD_BGA_CONSISTENCY_CHECK_STR = "Consistency Check";
	const LD_BGA_INIT_QUICK = 8;
	const LD_BGA_INIT_QUICK_STR = "Fast Initialization";
	const LD_BGA_INIT_BACK = 16;
	const LD_BGA_INIT_BACK_STR = "Background Initialization";
	const LD_BGA_MIGRATION = 32;
	const LD_BGA_MIGRATION_STR = "Migration";
	const LD_BGA_INIT_FORE = 64;
	const LD_BGA_INIT_FORE_STR = "Foreground Initialization";
	const LD_BGA_COPYBACK =128;
	const LD_BGA_COPYBACK_STR = "Copy Back";
	const LD_BGA_UNKNOWN_STR = "Unknown bga action";
	
	public static function getLdBgaStatusStr($Status)
	{
		$RetStr = "";
		switch ($Status)
		{
			case self::LD_BGA_NONE :
				$RetStr = self::LD_BGA_NONE_STR;
				break;
			case self::LD_BGA_REBUILD :
				$RetStr = self::LD_BGA_REBUILD_STR;
				break;
			case self::LD_BGA_CONSISTENCY_FIX :
				$RetStr = self::LD_BGA_CONSISTENCY_FIX_STR;
				break;
			case self::LD_BGA_CONSISTENCY_CHECK :
				$RetStr = self::LD_BGA_CONSISTENCY_CHECK_STR;
				break;
			case self::LD_BGA_INIT_QUICK :
				$RetStr = self::LD_BGA_INIT_QUICK_STR;
				break;
			case self::LD_BGA_INIT_BACK :
				$RetStr = self::LD_BGA_INIT_BACK_STR;
				break;
			case self::LD_BGA_MIGRATION :
				$RetStr = self::LD_BGA_MIGRATION_STR;	
				break;
			case self::LD_BGA_INIT_FORE :
				$RetStr = self::LD_BGA_INIT_FORE_STR;	
				break;
			case self::LD_BGA_COPYBACK :
				$RetStr = self::LD_BGA_COPYBACK_STR;	
				break;
			default:
				$RetStr = self::LD_BGA_UNKNOWN_STR ;
		}
		return $RetStr;
	}
	
	public static function getLdBgaString($status)
	{
		$RetStr = '';
		switch ($status)
		{
			case self::LD_BGA_NONE :
				$RetStr = 'none';
				break;
			case self::LD_BGA_REBUILD :
				$RetStr = 'rebuilt';
				break;
			case self::LD_BGA_CONSISTENCY_FIX :
				$RetStr = 'consistency fixed';
				break;
			case self::LD_BGA_CONSISTENCY_CHECK :
				$RetStr = 'consistency checked';
				break;
			case self::LD_BGA_INIT_QUICK :
				$RetStr = 'quick initialized';
				break;
			case self::LD_BGA_INIT_BACK :
				$RetStr = 'background initialized';
				break;
			case self::LD_BGA_MIGRATION :
				$RetStr = 'migrated';	
				break;
			case self::LD_BGA_INIT_FORE :
				$RetStr = 'foreground initialized';
				break;
			case self::LD_BGA_COPYBACK :
				$RetStr = 'copy backed';	
				break;
			default:
				$RetStr = 'unknown bga action';
		}
		return $RetStr;
	}
}

class LdBgaState
{
	const LD_BGA_STATE_NONE = 0;
	const LD_BGA_STATE_NONE_STR = "none";
	const LD_BGA_STATE_RUNNING = 1;
	const LD_BGA_STATE_RUNNING_STR = "running";
	const LD_BGA_STATE_ABORTED = 2;
	const LD_BGA_STATE_ABORTED_STR = "aborted";
	const LD_BGA_STATE_PAUSED = 3;
	const LD_BGA_STATE_PAUSED_STR = "paused";
	const LD_BGA_STATE_AUTOPAUSED = 4;
	const LD_BGA_STATE_AUTOPAUSED_STR = "auto paused";
	const LD_BGA_STATE_DDF_PENDING = 128;
	const LD_BGA_STATE_DDF_PENDING_STR = "DDF pending";
	
	public static function getLdBgaStateStr($BgaStateInt)
	{
		$RetStr = "";
		switch ($BgaStateInt)
		{
			case self::LD_BGA_STATE_NONE :
				$RetStr = self::LD_BGA_STATE_NONE_STR;
				break;
			case self::LD_BGA_STATE_RUNNING :
				$RetStr = self::LD_BGA_STATE_RUNNING_STR;
				break;
			case self::LD_BGA_STATE_ABORTED :
				$RetStr = self::LD_BGA_STATE_ABORTED_STR;
				break;
			case self::LD_BGA_STATE_PAUSED :
				$RetStr = self::LD_BGA_STATE_PAUSED_STR;
				break;
			case self::LD_BGA_STATE_AUTOPAUSED :
				$RetStr = self::LD_BGA_STATE_AUTOPAUSED_STR;
				break;
			case self::LD_BGA_STATE_DDF_PENDING :
				$RetStr = self::LD_BGA_STATE_DDF_PENDING_STR;
				break;
			default:
				$RetStr = self::LD_BGA_STATE_NONE_STR;
		}
		return $RetStr;
	}
}

class BgaControl
{
	const BGA_CONTROL_START = 0;
	const BGA_CONTROL_START_STR = "start";
	const BGA_CONTROL_RESTART = 1;
	const BGA_CONTROL_RESTART_STR = "restart";
	const BGA_CONTROL_PAUSE = 2;
	const BGA_CONTROL_PAUSE_STR = "pause";
	const BGA_CONTROL_RESUME = 3;
	const BGA_CONTROL_RESUME_STR = "resume";
	const BGA_CONTROL_ABORT = 4;
	const BGA_CONTROL_ABORT_STR = "stop";
	const BGA_CONTROL_COMPLETE = 5;
	const BGA_CONTROL_COMPLETE_STR = "complete";
	const BGA_CONTROL_IN_PROCESS = 6;
	const BGA_CONTROL_IN_PROCESS_STR = "inprogress";
	const BGA_CONTROL_TERMINATE_IMMEDIATE = 7;
	const BGA_CONTROL_TERMINATE_IMMEDIATE_STR = "term";
	const BGA_CONTROL_AUTO_PAUSE = 8;
	const BGA_CONTROL_AUTO_PAUSE_STR = "autopause";
	
	public static function getBgaControlValue($str)
	{
		switch ($str)
		{
			case self::BGA_CONTROL_START_STR :
				return self::BGA_CONTROL_START;
			case self::BGA_CONTROL_RESTART_STR  :
				return self::BGA_CONTROL_RESTART;
			case self::BGA_CONTROL_PAUSE_STR :
				return self::BGA_CONTROL_PAUSE;
			case self::BGA_CONTROL_RESUME_STR  :
				return self::BGA_CONTROL_RESUME ;
			case self::BGA_CONTROL_ABORT_STR  :
				return self::BGA_CONTROL_ABORT ;
			case self::BGA_CONTROL_COMPLETE_STR  :
				return self::BGA_CONTROL_COMPLETE ;
			case self::BGA_CONTROL_IN_PROCESS_STR  :
				return self::BGA_CONTROL_IN_PROCESS ;
			case self::BGA_CONTROL_TERMINATE_IMMEDIATE_STR  :
				return self::BGA_CONTROL_TERMINATE_IMMEDIATE ;
			
		}
		
		return 0;
	}
}

class BGARate
{
	const MAX_BGA_RATE = 0xFA;
	
	public static function RateToPercentage($rate)
	{
		return round($rate * 100 / self::MAX_BGA_RATE);
	}
	
	public static function PercentageToRate($per)
	{
		return round($per * self::MAX_BGA_RATE / 100);
	}
}

class BgaRateRange
{
	const MaxBgaRate = 250;
	const MinBgaRate = 0;
}

class BlockFlag
{
	const INVALID = 0;
	const VALID = 1;
	const ASSIGNED = 2;
	const BLOCK_FLAG_REBUILDING = 4;
	const BLOCK_FLAG_TEMP_ASSIGN = 8;
}

class LDCacheMode
{
	const WRITEBACK_ENABLE = 0;
	const WRITEBACK_ENABLE_STR = "Write Back(Performance)";
	const WRITEBACK_ENABLE_STATUS_STR = "Write Back";
	
	const WRITETHRU_ENABLE = 1;
	const WRITETHRU_ENABLE_STR = "Write Through(Reliable)";
	const WRITETHRU_ENABLE_STATUS_STR = "Write Through";
	
	const ADAPTIVE_ENABLE = 2;
	const ADAPTIVE_ENABLE_STR = "Auto";
	
	const AUTO_ENABLE = 8;
	const AUTO_ENABLE_STR = "Auto";
	
	const WRITE_POLICY_FILTER = 11;
	
	const LOOKAHEAD_ENABLE = 4;
	const LOOKAHEAD_ENABLE_STR = "Read Ahead";
	const NO_LOOKAHEAD_STR = "No Read Ahead";
	
	public static function getWriteCacheModeStr($wCache){
		$Str = "";
		if ($wCache & self::AUTO_ENABLE) {//clear 'auto' bit
			$wCache &= ~self::AUTO_ENABLE; 
		}
		if ($wCache == self::WRITEBACK_ENABLE) {
			$Str .= self::WRITEBACK_ENABLE_STATUS_STR ;
		} elseif ($wCache == self::WRITETHRU_ENABLE) {
			$Str .= self::WRITETHRU_ENABLE_STATUS_STR ;
		}
		return $Str;
	}
}

class LDStripeSize
{
	const StripeSize16K = 16;
	const StripeSize16KStr = "16K";
	const StripeSize32K = 32;
	const StripeSize32KStr = "32K";
	const StripeSize64K = 64;
	const StripeSize64KStr = "64K";
	const StripeSize128K = 128;
	const StripeSize128KStr = "128K";
	const StripeSize256K = 256;
	const StripeSize256KStr = "256K";
	const StripeSize512K = 512;
	const StripeSize512KStr = "512K";
	const StripeSize1024K = 1024;
	const StripeSize1024KStr = "1024K";
}

class LDSectorSize
{
	const SectorSize512B = 1;
	const SectorSize512BStr = "512B";
	const SectorSize1024B = 2;
	const SectorSize1024BStr = "1024B";
	const SectorSize2048B = 4;
	const SectorSize2048BStr = "2048B";
	const SectorSize4096B = 8;
	const SectorSize4096BStr = "4096B";
}

class EventRel
{
	const LD_EVENT = 1;
	const HD_EVENT = 2;
	const ADAPTER_EVENT = 4;
	const EXPANDER_EVENT = 8;
	const MDD_EVENT = 16;
	const BSL_EVENT = 32;
	
}

define("EVENTALL",EventRel::HD_EVENT | EventRel::LD_EVENT |
				EventRel::ADAPTER_EVENT | EventRel::MDD_EVENT |
				EventRel::BSL_EVENT | EventRel::EXPANDER_EVENT);
				
class EventNotifyType
{
	const NOTIFY_LEVEL_COUNT = 3;
	const ERROR = 4;
	const ERROR_STR = 'Error';
	const WARNING = 2;
	const WARNING_STR = 'Warning';
	const INFO = 1;
	const INFO_STR = 'Info';
	
	private $minServerity;
	private $maxServerity;
	
	public static function getEventNotifyTypeStr($Type)
	{
		switch ($Type)
		{
			case self::ERROR:
				return self::ERROR_STR ;
			case self::WARNING :
				return self::WARNING_STR ;
			case self::INFO :
				return self::INFO_STR  ;
			default:
				return 'None';
		}
	}
}
				
class DeviceType
{
	const DEVICE_TYPE_NONE = 0;
	const DEVICE_TYPE_NONE_STR = "None";
	const DEVICE_TYPE_HD = 1;
	const DEVICE_TYPE_HD_STR = "Physical Disk";
	const DEVICE_TYPE_PM = 2;
	const DEVICE_TYPE_PM_STR = "Port Multiplier";
	const DEVICE_TYPE_EXPANDER = 3;
	const DEVICE_TYPE_EXPANDER_STR = "Expander";	
	const DEVICE_TYPE_TAPE = 4;
	const DEVICE_TYPE_TAPE_STR = "Tape";
	const DEVICE_TYPE_PRINTER = 5;
	const DEVICE_TYPE_PRINTER_STR = "Printer";
	const DEVICE_TYPE_PROCESSOR = 6;
	const DEVICE_TYPE_PROCESSOR_STR = "Processor";
	const DEVICE_TYPE_WRITE_ONCE = 7;
	const DEVICE_TYPE_WRITE_ONCE_STR = "Write Once Device";
	const DEVICE_TYPE_CD_DVD = 8;
	const DEVICE_TYPE_CD_DVD_STR = "CD/DVD";
	const DEVICE_TYPE_OPTICAL_MEMORY = 9;
	const DEVICE_TYPE_OPTICAL_MEMORY_STR = "Optical Memory";
	const DEVICE_TYPE_MEDIA_CHANGER = 10;
	const DEVICE_TYPE_MEDIA_CHANGER_STR = "Media Changer";
	const DEVICE_TYPE_ENCLOSURE = 11;
	const DEVICE_TYPE_ENCLOSURE_STR = "Enclosure";
	const DEVICE_TYPE_PORT = 0xff;
	const DEVICE_TYPE_PORT_STR = "HBA";
	
	const DEVICE_TYPE_UNKNOWN_STR = "Unknown Device";
	
	public static function getDeviceTypeStr($DeviceType)
	{
		switch ($DeviceType)
		{
			case self::DEVICE_TYPE_NONE :
				return self::DEVICE_TYPE_NONE_STR;
			case self::DEVICE_TYPE_HD :
				return self::DEVICE_TYPE_HD_STR;
			case self::DEVICE_TYPE_PM :
				return self::DEVICE_TYPE_PM_STR;
			case self::DEVICE_TYPE_EXPANDER :
				return self::DEVICE_TYPE_EXPANDER_STR;				
			case self::DEVICE_TYPE_TAPE :
				return self::DEVICE_TYPE_TAPE_STR;
			case self::DEVICE_TYPE_PRINTER :
				return self::DEVICE_TYPE_PRINTER_STR;
			case self::DEVICE_TYPE_PROCESSOR :
				return self::DEVICE_TYPE_PROCESSOR_STR;
			case self::DEVICE_TYPE_WRITE_ONCE :
				return self::DEVICE_TYPE_WRITE_ONCE_STR;
			case self::DEVICE_TYPE_CD_DVD :
				return self::DEVICE_TYPE_CD_DVD_STR;
			case self::DEVICE_TYPE_OPTICAL_MEMORY :
				return self::DEVICE_TYPE_OPTICAL_MEMORY_STR;
			case self::DEVICE_TYPE_MEDIA_CHANGER :
				return self::DEVICE_TYPE_MEDIA_CHANGER_STR;
			case self::DEVICE_TYPE_ENCLOSURE :
				return self::DEVICE_TYPE_ENCLOSURE_STR;				
			case self::DEVICE_TYPE_PORT :
				return self::DEVICE_TYPE_PORT_STR;
			default:
				return self::DEVICE_TYPE_UNKNOWN_STR;
		}
	}
}

class HdSetStatus
{
	const HD_STATUS_SETONLINE = 0;
	const HD_STATUS_SETOFFLINE = 1;
	const HD_STATUS_FORCESETOFFLINE = 2;
	const HD_STATUS_SETFREE = 3;
	
	const HD_STATUS_INVALID = 0xff;
}

class HdStatus
{
	const HD_STATUS_FREE = 1;
	const HD_STATUS_ASSIGNED = 2;
	const HD_STATUS_SPARE = 4;
	const HD_STATUS_OFFLINE = 8;
	const HD_STATUS_SMARTCHECKING = 16;
	const HD_STATUS_MP = 32;
	const HD_STATUS_DEDICATED_SPARE = 64;
	const HD_STATUS_FOREIGN = 128;
	
	const HD_STATUS_ASSIGNED_IMG = "Drive_Green.gif";//configured
	const HD_STATUS_ASSIGNED_SPARE_IMG = "Drive_Green_Spare.gif";//configured spare
	const HD_STATUS_FREE_IMG = "Drive_Blue.gif";//free
	const HD_STATUS_SPARE_IMG = "Drive_Spare.gif";//free
	const HD_STATUS_OFFLINE_IMG = "Drive_Offline.gif";//offline
	const HD_STATUS_FOREIGN_IMG = "Drive_Foreign.gif";//foreign
	
	const HD_STATUS_ASSIGNED_STR = 'Configured';
	const HD_STATUS_FREE_STR = 'Unconfigured';
	const HD_STATUS_OFFLINE_STR = 'Offline';
	const HD_STATUS_FOREIGN_STR = 'Foreign';
	
	public static function getHDStatusStr($status)
	{
		$RetStr = "";
		if (HdStatus::HD_STATUS_FREE & $status) {
			$RetStr .= self::HD_STATUS_FREE_STR;
		}
		else if (HdStatus::HD_STATUS_ASSIGNED & $status) 
		{
			$RetStr .= self::HD_STATUS_ASSIGNED_STR;
		}
		else if (HdStatus::HD_STATUS_OFFLINE & $status)
		{
			$RetStr .= self::HD_STATUS_OFFLINE_STR;
		}		
		else// if (HdStatus::HD_STATUS_FOREIGN & $status)  //default
		{
			$RetStr .= self::HD_STATUS_FOREIGN_STR;
		}		
		return $RetStr;
	}
	
	/*
	public static function getHDImg($StatusInt)
	{
		$RetImg = "";
		switch ($StatusInt)
		{
			case self::HD_STATUS_ASSIGNED :
				$RetImg = self::HD_STATUS_ASSIGNED_IMG;
				break;
			case self::HD_STATUS_FREE :
				$RetImg = self::HD_STATUS_FREE_IMG;
				break;
			case self::HD_STATUS_OFFLINE :
				$RetImg = self::HD_STATUS_OFFLINE_IMG;
				break;
			default:
				$RetImg = self::HD_STATUS_OFFLINE_IMG;
				break;
		}
		return $RetImg;
	}
	*/
}
class HdBgaStatus
{
	const HD_BGA_NONE = 0;
	const HD_BGA_NONE_STR = 'None';
	const HD_BGA_MP = 1;
	const HD_BGA_MP_STR = 'Media Patrol';
	const HD_BGA_TYPE_DATASCRUB = 2;
	const HD_BGA_TYPE_DATASCRUB_STR = 'Data Scrub';
	
	public static function getHdBgaStatusStr($Status)
	{
		$RetStr = "";
		switch ($Status)
		{
			case self::HD_BGA_MP :
				$RetStr = self::HD_BGA_MP_STR;
				break;
			case self::HD_BGA_TYPE_DATASCRUB :
				$RetStr = self::HD_BGA_TYPE_DATASCRUB_STR ;
				break;
			default:
				$RetStr = self::HD_BGA_NONE_STR;
		}
		return $RetStr;
	}
}

class HdBgaState   //the same as LdBgaState
{
	const HD_BGA_STATE_NONE = 0;
	const HD_BGA_STATE_NONE_STR = "none";
	const HD_BGA_STATE_RUNNING = 1;
	const HD_BGA_STATE_RUNNING_STR = "running";
	const HD_BGA_STATE_ABORTED = 2;
	const HD_BGA_STATE_ABORTED_STR = "aborted";
	const HD_BGA_STATE_PAUSED = 3;
	const HD_BGA_STATE_PAUSED_STR = "paused";
	const HD_BGA_STATE_AUTOPAUSED = 4;
	const HD_BGA_STATE_AUTOPAUSED_STR = "auto paused";
	const HD_BGA_STATE_DDF_PENDING = 128;
	const HD_BGA_STATE_DDF_PENDING_STR = "DDF pending";
	
	public static function getHdBgaStatusStr($Status)
	{
		$RetStr = "";
		switch ($Status)
		{
			case self::HD_BGA_STATE_NONE  :
				$RetStr = self::HD_BGA_STATE_NONE_STR;
				break;
			case self::HD_BGA_STATE_RUNNING :
				$RetStr = self::HD_BGA_STATE_RUNNING_STR;
				break;
			case self::HD_BGA_STATE_ABORTED  :
				$RetStr = self::HD_BGA_STATE_ABORTED_STR ;
				break;
			case self::HD_BGA_STATE_AUTOPAUSED  :
				$RetStr = self::HD_BGA_STATE_AUTOPAUSED_STR ;
				break;
			case self::HD_BGA_STATE_PAUSED  :
				$RetStr = self::HD_BGA_STATE_PAUSED_STR ;
				break;
			case self::HD_BGA_STATE_DDF_PENDING  :
				$RetStr = self::HD_BGA_STATE_DDF_PENDING_STR ;	
				break;
			default:
				$RetStr = self::HD_BGA_STATE_NONE_STR;
		}
		return $RetStr;
	}
	
}


class HdType
{
	const HD_TYPE_SATA = 1;
	const SATA_HD = "SATA";
	
	const HD_TYPE_PATA = 2;
	const PATA_HD = "PATA";
	
	const HD_TYPE_SAS = 4;
	const SAS_HD = "SAS";
	
	const HD_TYPE_ATAPI = 8;
	const ATAPI_HD = "ATAPI";
	
	const HD_TYPE_TAPE = 16;
	const TAPE_HD = "TAPE";
	
	const HD_TYPE_SES = 32;
	const SES_HD = "SES";
	
	const UNKNOWN_HD = "Unknown";
	
	public static function getHdTypeStr($HDTypeInt)
	{
		$Ret = "";
		if ($HDTypeInt & self::HD_TYPE_SATA ) {
			$Ret = self::SATA_HD;
		}		
		elseif ($HDTypeInt & self::HD_TYPE_PATA ) {
			$Ret = self::PATA_HD;
		}
		elseif ($HDTypeInt & self::HD_TYPE_SAS) {
			$Ret = self::SAS_HD;
		}
		else {
			$Ret = self::UNKNOWN_HD;
		}
		
		// The following flags are in addtion to the above ones.
		if ($HDTypeInt & self::HD_TYPE_ATAPI ) {
			$Ret .= " " . self::ATAPI_HD;
		}
		elseif ($HDTypeInt & self::HD_TYPE_TAPE ) {
			$Ret .= " " . self::TAPE_HD;
		}
		elseif ($HDTypeInt & self::HD_TYPE_SES ) {
			$Ret .= " " . self::SES_HD;
		}
		
		return $Ret;
	}
}

// PD's Protocol/Connection type (used by new driver)
class DCType
{
	const DC_ATA = 1;
	const DC_SCSI = 2;
	const DC_SERIAL = 4;
	const DC_PARALLEL = 8;
	const DC_ATAPI = 16;
	const DC_SGPIO = 32;
	
	public static function getDCTypeStr($DCType)
	{
		$Ret = "";
		if ((self::DC_ATA & $DCType) && (self::DC_SERIAL & $DCType)) {
			$Ret = "SATA";
		}else if ((self::DC_ATA & $DCType) && (self::DC_PARALLEL & $DCType)) {
			$Ret = "PATA";
		}else if ((self::DC_SCSI & $DCType) && (self::DC_SERIAL & $DCType)) {
			$Ret = "SAS";
		}
		
		/*
		if (self::DC_ATAPI & $DCType) {
			$Ret .= ' ' . 'ATAPI';
		}
		*/
		
		return $Ret;
	}
}

// PD's Device type defined in SCSI-III specification (used by new driver)
class DTType
{
	const DT_DIRECT_ACCESS_BLOCK = 0x00;
	const DT_DIRECT_ACCESS_BLOCK_STR = 'PD';
	const DT_SEQ_ACCESS = 0x01;
	const DT_SEQ_ACCESS_STR = 'TAPE';
	const DT_PRINTER = 0x02;
	const DT_PRINTER_STR = 'PRINTER';
	const DT_PROCESSOR = 0x03;
	const DT_WRITE_ONCE = 0x04;
	const DT_CD_DVD = 0x05;
	const DT_CD_DVD_STR = 'CD_DVD';
	const DT_OPTICAL_MEMORY = 0x07;
	const DT_MEDIA_CHANGER = 0x08;
	const DT_STORAGE_ARRAY_CTRL = 0x0C;
	const DT_ENCLOSURE = 0x0D;
	const DT_ENCLOSURE_STR = 'ENCLOSURE';
	// The following are defined by Marvell
	const DT_EXPANDER = 0x20;
	const DT_PM = 0x21;
	
	public static function getDTType($DTType)
	{
		if (self::DT_DIRECT_ACCESS_BLOCK == $DTType) {
			return self::DT_DIRECT_ACCESS_BLOCK_STR;
		}else if (self::DT_SEQ_ACCESS == $DTType) {
			return self::DT_SEQ_ACCESS_STR;
		}else if (self::DT_PRINTER == $DTType) {
			return self::DT_PRINTER_STR;
		}else if (self::DT_CD_DVD == $DTType) {
			return self::DT_CD_DVD_STR;
		}else if (self::DT_ENCLOSURE == $DTType) {
			return self::DT_ENCLOSURE_STR;
		}else {
			return "unknown";
		}
	}
}

class PdState
{
	const PD_STATE_ONLINE = 1;
	const PD_STATE_FAILED = 2;
	const PD_STATE_REBUILDING = 4;
	const PD_STATE_TRANSITION = 8;
	const PD_STATE_SMART_ERROR = 16;
	const PD_STATE_READ_ERROR = 32;
	const PD_STATE_MISSING = 64;
}

class HdSpeed
{
	const HD_SPEED_1_5G = 1;
	const HD_SPEED_3G = 2;
	const HD_SPEED_6G = 3;
}

class HdFeature
{	
	const HD_FEATURE_NCQ = 1;
	const STR_HD_FEATURE_NCQ = "NCQ";
	const HD_FEATURE_TCQ = 2;
	const STR_HD_FEATURE_TCQ = "TCQ";
	const HD_FEATURE_1_5G = 4;
	const STR_HD_FEATURE_1_5G = "1.5Gb/s";
	const HD_FEATURE_3G = 8;
	const STR_HD_FEATURE_3G = "3Gb/s";
	const HD_FEATURE_WRITE_CACHE = 16;
	const STR_HD_FEATURE_WRITE_CACHE = "Write Cache";
	const HD_FEATURE_48BITS = 32;
	const STR_HD_FEATURE_48BITS = "48Bits";
	const HD_FEATURE_SMART = 64;
	const STR_HD_FEATURE_SMART = "Smart";
	const HD_FEATURE_6G = 128;
	const STR_HD_FEATURE_6G = "6Gb/s";
	
	public static function getHdFeatureStr($Feature)
	{
		switch ($Feature)
		{
			case self::HD_FEATURE_1_5G :
				return self::STR_HD_FEATURE_1_5G ;
			case self::HD_FEATURE_NCQ :
				return self::STR_HD_FEATURE_NCQ ;
			case self::HD_FEATURE_TCQ :
				return self::STR_HD_FEATURE_TCQ ;
			case self::HD_FEATURE_3G :
				return self::STR_HD_FEATURE_3G ;
			case self::HD_FEATURE_WRITE_CACHE :
				return self::STR_HD_FEATURE_WRITE_CACHE ;
			case self::HD_FEATURE_48BITS :
				return self::STR_HD_FEATURE_48BITS ;
			case self::HD_FEATURE_SMART :
				return self::STR_HD_FEATURE_SMART ;
			case self::HD_FEATURE_6G :
				return self::STR_HD_FEATURE_6G ;
			default:
				return "Unknown";
		}
	}
}

//RCT entry flag
class RCTFlag
{
	/* request type related */
	const EH_READ_VERIFY_REQ_ERROR = 1; /* Read or Read Verify request is failed. */
	const STR_EH_READ_VERIFY_REQ_ERROR = "read error";
	const EH_WRITE_REQ_ERROR = 2;  /* Write request is failed */
	const STR_EH_WRITE_REQ_ERROR = "write error";
	/* error type related */
	const EH_MEDIA_ERROR = 8; /* Media Error or timeout */
	const STR_EH_MEDIA_ERROR = "media error";
	const EH_LOGICAL_ERROR = 16; /* Logical Error because of BGA activity. */
	const STR_EH_LOGICAL_ERROR = "logical error";
}

//Support LD Raid Mode

class SupportLdRaidMode
{
	const SUPPORT_LD_MODE_RAID0 = 1;
	const SUPPORT_LD_MODE_RAID1 = 2;
	const SUPPORT_LD_MODE_RAID10 = 4;
	const SUPPORT_LD_MODE_RAID1E = 8;
	const SUPPORT_LD_MODE_RAID5 = 16;
	const SUPPORT_LD_MODE_RAID6 = 32;
	const SUPPORT_LD_MODE_RAID50 = 64;
	const SUPPORT_LD_MODE_JBOD = 128;
	const SUPPORT_LD_MODE_RAID60 = 256;
}

class SupportStripeSize
{
	const STRIPE_SIZE_16 = 1;
	const STRIPE_SIZE_32 = 2;
	const STRIPE_SIZE_64 = 4;
	const STRIPE_SIZE_128 = 8;
	const STRIPE_SIZE_256 = 16;
	const STRIPE_SIZE_512 = 32;
	const STRIPE_SIZE_1024 = 64;
}

class PCIESpeed
{
	const PCIE_SPEED_UNKNOWN = 0;
	const PCIE_SPEED_GEN_I = 1;
	const PCIE_SPEED_GEN_II = 2;
	
	const PCIE_SPEED_UNKNOWN_STR = "Unknown";
	const PCIE_SPEED_GEN_I_STR = "2.5Gb/s";
	const PCIE_SPEED_GEN_II_STR = "5Gb/s";
	
	public static function getPCIESpeedStr($speed)
	{
		switch($speed)
		{
			case self::PCIE_SPEED_GEN_I:
				return self::PCIE_SPEED_GEN_I_STR;
			case self::PCIE_SPEED_GEN_II:
				return self::PCIE_SPEED_GEN_II_STR;
			default:
				return self::PCIE_SPEED_UNKNOWN_STR;
		}
	}
}

class HBAFeature
{
	const FEATURE_BGA_REBUILD_SUPPORT = 1;
	const FEATURE_BGA_BKINIT_SUPPORT = 2;
	const FEATURE_BGA_SYNC_SUPPORT = 4;
	const FEATURE_BGA_MIGRATION_SUPPORT = 8;
	const FEATURE_BGA_MEDIAPATROL_SUPPORT = 16;
	const FEATURE_BGA_FEINIT_SUPPORT = 32;
	const FEATURE_BGA_COPY_BACK_SUPPORT = 64;
	const FEATURE_PD_OF_SAME_TYPE_WHEN_CREATE_VD = 128;
}

//advance features
class HBAAdvFeature
{
	const ADV_FEATURE_EVENT_WITH_SENSE_CODE = 1;
	const ADV_FEATURE_BIG_STRTPE_SUPPORT = 2;
	const ADV_FEATURE_BIOS_OPTION_SUPPORT = 4;
	const ADV_FEATURE_HAS_BBU = 8;
	const ADV_FEATURE_CONFIG_IN_FLASH = 16;
	const ADV_FEATURE_CPU_EFFICIENCY_SUPPORT = 32;
	const ADV_FEATURE_NO_MUTIL_VD_PER_PD = 64;
	const ADV_FEATURE_SPC_4_BUFFER = 128;
	const ADV_FEATURE_SES_DIRECT = 256;
	const ADV_FEATURE_MODULE_CONSOLIDATE = 512;
}

//BBU features
class BBUFeature
{
	const BBU_SENSOR_TEMPERATURE = 1;
	const BBU_SENSOR_VOLTAGE = 2;
	const BBU_SENSOR_ECAPACITY = 4;
}

class BBUStatus
{
	const BBU_STATUS_NOT_PRESENT = 0x0000;
	const BBU_STATUS_NOT_PRESENT_STR = "not present";
	const BBU_STATUS_PRESENT = 0x0001;
	const BBU_STATUS_PRESENT_STR = "present";
	const BBU_STATUS_LOW_BATTERY = 0x0002;
	const BBU_STATUS_LOW_BATTERY_STR = "low battery";
	const BBU_STATUS_CHARGING = 0x0004;
	const BBU_STATUS_CHARGING_STR = "charging";
	const BBU_STATUS_FULL_CHARGED = 0x0008;
	const BBU_STATUS_FULL_CHARGED_STR = "full charged";
	const BBU_STATUS_DISCHARGE = 0x0010;
	const BBU_STATUS_DISCHARGE_STR = "discharge";
	const BBU_STATUS_RELEARN = 0x0020;
	const BBU_STATUS_RELEARN_STR = "relearn";
	const BBU_STATUS_OVER_TEMP_WARNING = 0x0040;
	const BBU_STATUS_OVER_TEMP_WARNING_STR = "over temperature warning";
	const BBU_STATUS_OVER_TEMP_ERROR = 0x0080;
	const BBU_STATUS_OVER_TEMP_ERROR_STR = "over temperature error";
	const BBU_STATUS_UNDER_TEMP_WARNING = 0x0100;
	const BBU_STATUS_UNDER_TEMP_WARNING_STR = "under temperature warning";
	const BBU_STATUS_UNDER_TEMP_ERROR = 0x0200;
	const BBU_STATUS_UNDER_TEMP_ERROR_STR = "under temperature error";
	const BBU_STATUS_OVER_VOLT_WARNING = 0x0400;
	const BBU_STATUS_OVER_VOLT_WARNING_STR = "over voltage warning";
	const BBU_STATUS_OVER_VOLT_ERROR = 0x0800;
	const BBU_STATUS_OVER_VOLT_ERROR_STR = "over voltage error";
	const BBU_STATUS_UNDER_VOLT_WARNING = 0x1000;
	const BBU_STATUS_UNDER_VOLT_WARNING_STR = "under voltage warning";
	const BBU_STATUS_UNDER_VOLT_ERROR = 0x2000;
	const BBU_STATUS_UNDER_VOLT_ERROR_STR = "under voltage error";
	
	public static function getBBUStatusStr($Status, $time_to_full, $time_to_empty)
	{
		$Str = "";
		if ($Status & self::BBU_STATUS_NOT_PRESENT ) {
			$Str = self::BBU_STATUS_NOT_PRESENT_STR ;
		} else {
			if ($Status & self::BBU_STATUS_LOW_BATTERY)
				$Str .= self::BBU_STATUS_LOW_BATTERY_STR . ", ";
			if ($Status & self::BBU_STATUS_FULL_CHARGED)
				$Str .= self::BBU_STATUS_FULL_CHARGED_STR . ", ";
			if ($Status & self::BBU_STATUS_DISCHARGE)
				$Str .= self::BBU_STATUS_DISCHARGE_STR . " and " . $time_to_empty . " minutes to empty" . ", ";
			if ($Status & self::BBU_STATUS_CHARGING)
				$Str .= self::BBU_STATUS_CHARGING_STR . " and " . $time_to_full . " minutes to full" . ", ";
			if ($Status & self::BBU_STATUS_RELEARN)
				$Str .= self::BBU_STATUS_RELEARN_STR . ", ";
			if ($Status & self::BBU_STATUS_OVER_TEMP_WARNING)
				$Str .= self::BBU_STATUS_OVER_TEMP_WARNING_STR . ", ";
			if ($Status & self::BBU_STATUS_OVER_TEMP_ERROR)
				$Str .= self::BBU_STATUS_OVER_TEMP_ERROR_STR . ", ";
			if ($Status & self::BBU_STATUS_UNDER_TEMP_WARNING)
				$Str .= self::BBU_STATUS_UNDER_TEMP_WARNING_STR . ", ";
			if ($Status & self::BBU_STATUS_UNDER_TEMP_ERROR)
				$Str .= self::BBU_STATUS_UNDER_TEMP_ERROR_STR . ", ";
			if ($Status & self::BBU_STATUS_OVER_VOLT_WARNING)
				$Str .= self::BBU_STATUS_OVER_VOLT_WARNING_STR . ", ";
			if ($Status & self::BBU_STATUS_OVER_VOLT_ERROR)
				$Str .= self::BBU_STATUS_OVER_VOLT_ERROR_STR . ", ";
			if ($Status & self::BBU_STATUS_UNDER_VOLT_WARNING)
				$Str .= self::BBU_STATUS_UNDER_VOLT_WARNING_STR . ", ";
			if ($Status & self::BBU_STATUS_UNDER_VOLT_ERROR)
				$Str .= self::BBU_STATUS_UNDER_VOLT_ERROR_STR . ", ";
			
			if (strlen($Str) > 2)
				$Str = substr($Str, 0, (strlen($Str)-2)); // get rid of last ", ".
		}
		if (strlen($Str) < 2)
			$Str = "Ok";
		return $Str;
	}
}
 
class QuickCreateType
{
	const CREATE_PERFORMANCE = 0;
	const CREATE_RELIABILITY = 1;
}

//initilization type

class InitType
{
	const INIT_QUICK = 0;
	const INIT_FULLFOREGROUND = 1;
	const INIT_FULLBACKGROUND = 2;
	const INIT_NONE = 3;
}

class Rounding_Scheme
{
	const ROUNDING_SCHEME_NONE = 0;
	const ROUNDING_SCHEME_1GB = 1;
	const ROUNDING_SCHEME_10GB = 2;
}

class ConsistencyCheck_Type
{
	const CONSISTENCYCHECK_ONLY = 0;
	const CONSISTENCYCHECK_FIX = 1;
}

//event class
class EventSeverity
{	
	const SEVERITY_UNKNOWN = 0;
	const SEVERITY_OTHER = 1;
	const SEVERITY_INFO = 2;
	const SEVERITY_WARNING = 3;  /* used when its appropriate to let the 
					  user decide if action is needed */
	const SEVERITY_MINOR = 4;  /* indicate action is needed, but the 
					  situation is not serious at this time */  
	const SEVERITY_MAJOR = 5 ; /* indicate action is needed NOW */
	const SEVERITY_CRITICAL = 6;  /* indicate action is needed NOW and the 
					  scope is broad */
	const SEVERITY_FATAL = 7;  /* indicate an error occurred, but it's too
				  late to take remedial action */
	
	const SEVERITY_WARNING_IMG = "EventLog_warning.gif";
	const SEVERITY_CRITICAL_IMG = "EventLog_critical.gif";
	const SEVERITY_INFO_IMG = "EventLog_info.gif";
	const SEVERITY_UNKNOWN_IMG = "EventLog_unknown.gif";
	
	const SEVERITY_WARNING_TITLE = "Warning";
	const SEVERITY_CRITICAL_TITLE = "Error";
	const SEVERITY_INFO_TITLE = "Info";
	const SEVERITY_UNKNOWN_TITLE = "Unknown";
	
	public static function getSeverityImg($SeverityInt)
	{
		//four level for event list display
		if ($SeverityInt == self::SEVERITY_UNKNOWN) {
			return self::SEVERITY_UNKNOWN_IMG;
		}else if (self::SEVERITY_OTHER <= $SeverityInt && self::SEVERITY_INFO >= $SeverityInt) {
			return self::SEVERITY_INFO_IMG;
		}else if (self::SEVERITY_WARNING <= $SeverityInt && self::SEVERITY_MINOR >= $SeverityInt) {
			return self::SEVERITY_WARNING_IMG;
		}else if (self::SEVERITY_MAJOR <= $SeverityInt && self::SEVERITY_FATAL >= $SeverityInt) {
			return self::SEVERITY_CRITICAL_IMG;
		}else {
			return self::SEVERITY_UNKNOWN_IMG;
		}
	}
	
	public static function getSeverityTitle($SeverityInt)
	{
		//four level for event list display
		if ($SeverityInt == self::SEVERITY_UNKNOWN) {
			return self::SEVERITY_UNKNOWN_TITLE;
		}else if (self::SEVERITY_OTHER <= $SeverityInt && self::SEVERITY_INFO >= $SeverityInt) {
			return self::SEVERITY_INFO_TITLE;
		}else if (self::SEVERITY_WARNING <= $SeverityInt && self::SEVERITY_MINOR >= $SeverityInt) {
			return self::SEVERITY_WARNING_TITLE;
		}else if (self::SEVERITY_MAJOR <= $SeverityInt && self::SEVERITY_FATAL >= $SeverityInt) {
			return self::SEVERITY_CRITICAL_TITLE;
		}else {
			return self::SEVERITY_UNKNOWN_TITLE;
		}
	}
	
	public static function getSeverityRegion($eventNotifyLevel)
	{
		//for event notify
		//return array with element 0 for min severity and element 1 for max severity
		//[minSeverity,maxSeverity] included close region
		
		if ($eventNotifyLevel == EventNotifyType::ERROR ) {
			return array(self::SEVERITY_MAJOR, self::SEVERITY_FATAL);
		}
		if ($eventNotifyLevel == EventNotifyType::WARNING ) {
			return array(self::SEVERITY_WARNING, self::SEVERITY_MINOR);
		}
		if ($eventNotifyLevel == EventNotifyType::INFO ) {
			return array(self::SEVERITY_OTHER, self::SEVERITY_INFO);
		}
		else 
		{
			return array(-1,-1);
		}
	}
}

class EventClass
{
	const EVT_CLASS_ADAPTER = 0;
	const EVT_CLASS_ADAPTER_STR = "Adapter Event";
	const EVT_CLASS_LD = 1;
	const EVT_CLASS_LD_STR = "VD Event";
	const EVT_CLASS_HD = 2;
	const EVT_CLASS_HD_STR = "PD Event";
	const EVT_CLASS_PM = 3;
	const EVT_CLASS_PM_STR = "PM Event";
	const EVT_CLASS_EXPANDER = 4;
	const EVT_CLASS_EXPANDER_STR = "Expander Event";
	const EVT_CLASS_MDD = 5;
	const EVT_CLASS_MDD_STR = "MDD Event";
	const EVT_CLASS_BSL = 6;
	const EVT_CLASS_BSL_STR = "BSL Event";                                                 
	const EVT_CLASS_SAS = 7;		// SAS, mainly for SAS topology    
	const EVT_CLASS_SAS_STR = "SAS Event";     
	const EVT_CLASS_ENCL = 8;		// Enclosure      
	const EVT_CLASS_ENCL_STR = "Enclosure Event";                      
	const EVT_CLASS_BAT = 9 ;      // Battery      
	const EVT_CLASS_BAT_STR = "Battery Event";                                
	const EVT_CLASS_FLASH = 10;      // Flash memory   
	const EVT_CLASS_FLASH_STR = "Flash memory Event";                              
	const EVT_CLASS_CACHE = 11;      // Cache related   
	const EVT_CLASS_CACHE_STR = "Cache related Event";                                         
	const EVT_CLASS_MISC = 12;      // For other miscellaneous events 
	const EVT_CLASS_MISC_STR = "Miscellaneous Event";
	const EVT_CLASS_ARRAY = 13;
	const EVT_CLASS_ARRAY_STR = "Array Event";
	const EVT_CLASS_UNKNOWN = "Unknown Event Class";

	public static function getEventClassStr($EventClassInt)
	{
		switch ($EventClassInt)
		{
			case self::EVT_CLASS_ADAPTER :
				return self::EVT_CLASS_ADAPTER_STR ;
			case self::EVT_CLASS_LD :
				return self::EVT_CLASS_LD_STR ;
			case self::EVT_CLASS_HD :
				return self::EVT_CLASS_HD_STR ;
			case self::EVT_CLASS_PM :
				return self::EVT_CLASS_PM_STR ;
			case self::EVT_CLASS_EXPANDER :
				return self::EVT_CLASS_EXPANDER_STR ;
			case self::EVT_CLASS_MDD :
				return self::EVT_CLASS_MDD_STR ;
			case self::EVT_CLASS_BSL :
				return self::EVT_CLASS_BSL_STR ;
			case self::EVT_CLASS_SAS :
				return self::EVT_CLASS_SAS_STR ;
			case self::EVT_CLASS_ENCL :
				return self::EVT_CLASS_ENCL_STR ;
			case self::EVT_CLASS_BAT :
				return self::EVT_CLASS_BAT_STR ;
			case self::EVT_CLASS_FLASH :
				return self::EVT_CLASS_FLASH_STR ;
			case self::EVT_CLASS_CACHE :
				return self::EVT_CLASS_CACHE_STR ;
			case self::EVT_CLASS_MISC :
				return self::EVT_CLASS_MISC_STR ;
			case self::EVT_CLASS_ARRAY :
				return self::EVT_CLASS_ARRAY_STR ;
			default:
				return self::EVT_CLASS_UNKNOWN;
		}
	}
}

class EventMsg
{
	const EVT_CODE_EVT_ERR = "Event(s) lost: Current seqNum %1, last seqNum %2";
	
	//for application use
	const EVT_CODE_SMART_FROM_OFF_TO_ON = "SMART has been enabled";
	const EVT_CODE_SMART_FROM_ON_TO_OFF = "SMART has been disabled";
	const EVT_CODE_ALARM_TURN_ON = "Alarm has been enabled";
	const EVT_CODE_ALARM_TURN_OFF = "Alarm has been disabled";
	const EVT_CODE_AUTO_REBUILD_ON = "Auto-rebuild has been enabled";
	const EVT_CODE_AUTO_REBUILD_OFF = "Auto-rebuild has been disabled";
	const EVT_CODE_HD_MP_RATE_CHANGE = "Media patrol rate has been changed";
	const EVT_CODE_COPY_BACK_ON = "Copy back has been enabled";
	const EVT_CODE_COPY_BACK_OFF = "Copy back has been disabled";
	const EVT_CODE_ADAPTER_FOUND = "Adapter %1 with serial number %2 is detected";
	const EVT_CODE_BBU_ECCERROR = "Battery backup unit found an ECC (Error Checking and Correcting) wrong error";
	const EVT_CODE_ADAPTER_BBU_COUNT = "Auto cache flashed %3/%2 data";
	const EVT_CODE_ADAPTER_BBU_START = "Auto starts flush dirty data";
	const EVT_CODE_ADAPTER_BBU_FINISH = "Auto finish flush dirty data";
	const EVT_CODE_PAGE_ECC_ERROR = "Page data has an ECC (Error Checking and Correcting) wrong error and can not be flushed";
	const EVT_CODE_ADAPTER_FOUND_NO_SERIAL = "Adapter %1 is detected, serial number not available";
	
	//LD event
	const EVT_Unknown_Adpt = "Unknown event %1";
	const EVT_CODE_LD_OFFLINE = "Virtual disk %1 is offline";
	const EVT_CODE_LD_ONLINE = "Virtual disk %1 is online";
	const EVT_CODE_LD_CREATE = "Virtual disk %1 is created";
	const EVT_CODE_LD_DELETE = "Virtual disk %1 is deleted";
	const EVT_CODE_LD_DEGRADE = "Virtual disk %1 is degraded";
	const EVT_CODE_LD_PARTIALLYOPTIMAL = "Virtual disk %1 lost a redundancy disk";
	//const EVT_CODE_LD_CRITICAL = "Virtual disk %1 is in critical condition";
	const EVT_CODE_LD_CACHE_MODE_CHANGE = "Cache mode on virtual disk %1 has been changed";
	const EVT_CODE_LD_FIXED = "Synchronization on virtual disk %1 succeeded";
	const EVT_CODE_LD_FOUND_ERROR = "Synchronization on virtual disk %1 failed";
	const EVT_CODE_LD_IMPORTED = "Virtual disk %1 has been imported into disk array %2";
	
	const EVT_CODE_LD_CHECK_START = "Consistency check on virtual disk %1 started";
	const EVT_CODE_LD_CHECK_RESTART = "Consistency check on virtual disk %1 restarted";
	const EVT_CODE_LD_CHECK_PAUSE = "Consistency check on virtual disk %1 paused";
	const EVT_CODE_LD_CHECK_RESUME = "Consistency check on virtual disk %1 resumed";
	const EVT_CODE_LD_CHECK_ABORT = "Consistency check on virtual disk %1 aborted";
	const EVT_CODE_LD_CHECK_COMPLETE = "Consistency check on virtual disk %1 completed";
	const EVT_CODE_LD_CHECK_PROGRESS = "Consistency check on virtual disk %1 is %2% done";
	const EVT_CODE_LD_CHECK_ERROR = "Consistency check on virtual disk %1 failed";
	const EVT_CODE_LD_CHECK_AUTO_PAUSED = "Consistency check on virtual disk %1 auto paused";
	const EVT_CODE_LD_CHECK_AUTO_RESUME = "Consistency check on virtual disk %1 auto resumed";
	const EVT_CODE_LD_FIX_START = "Consistency fix on virtual disk %1 started";
	const EVT_CODE_LD_FIX_RESTART = "Consistency fix on virtual disk %1 restarted";
	const EVT_CODE_LD_FIX_PAUSE = "Consistency fix on virtual disk %1 paused";
	const EVT_CODE_LD_FIX_RESUME = "Consistency fix on virtual disk %1 resumed";
	const EVT_CODE_LD_FIX_ABORT = "Consistency fix on virtual disk %1 aborted";
	const EVT_CODE_LD_FIX_COMPLETE = "Consistency fix on virtual disk %1 completed";
	const EVT_CODE_LD_FIX_PROGRESS = "Consistency fix on virtual disk %1 is %2% done";
	const EVT_CODE_LD_FIX_ERROR = "Consistency fix on virtual disk %1 failed";
	const EVT_CODE_LD_FIX_AUTO_PAUSED = "Consistency fix on virtual disk %1 is auto paused";
	const EVT_CODE_LD_FIX_AUTO_RESUME = "Consistency fix on virtual disk %1 is auto resumed";
	const EVT_CODE_LD_INIT_QUICK_START = "Fast initialization on virtual disk %1 started";
	const EVT_CODE_LD_INIT_QUICK_RESTART = "Fast initialization on virtual disk %1 restarted";
	const EVT_CODE_LD_INIT_QUICK_PAUSE = "Fast initialization on virtual disk %1 paused";
	const EVT_CODE_LD_INIT_QUICK_RESUME = "Fast initialization on virtual disk %1 resumed";
	const EVT_CODE_LD_INIT_QUICK_ABORT = "Fast initialization on virtual disk %1 aborted";
	const EVT_CODE_LD_INIT_QUICK_COMPLETE = "Fast initialization on virtual disk %1 completed";
	const EVT_CODE_LD_INIT_QUICK_PROGRESS = "Fast initialization on virtual disk %1 is %2% done";
	const EVT_CODE_LD_INIT_QUICK_ERROR = "Fast initialization on virtual disk %1 failed";
	const EVT_CODE_LD_INIT_QUICK_AUTO_PAUSED = "Fast initialization on virtual disk %1 auto paused";
	const EVT_CODE_LD_INIT_QUICK_AUTO_RESUME = "Fast initialization on virtual disk %1 auto resumed";
	//10 events for Background initialization
	const EVT_CODE_LD_INIT_BACK_START = "Background initialization on virtual disk %1 started";
	const EVT_CODE_LD_INIT_BACK_RESTART = "Background initialization on virtual disk %1 restarted";
	const EVT_CODE_LD_INIT_BACK_PAUSE = "Background initialization on virtual disk %1 paused";
	const EVT_CODE_LD_INIT_BACK_RESUME = "Background initialization on virtual disk %1 resumed";
	const EVT_CODE_LD_INIT_BACK_ABORT = "Background initialization on virtual disk %1 aborted";
	const EVT_CODE_LD_INIT_BACK_COMPLETE = "Background initialization on virtual disk %1 completed";
	const EVT_CODE_LD_INIT_BACK_PROGRESS = "Background initialization on virtual disk %1 is %2% done";
	const EVT_CODE_LD_INIT_BACK_ERROR = "Background initialization on virtual disk %1 failed";
	const EVT_CODE_LD_INIT_BACK_AUTO_PAUSED = "Background initialization on virtual disk %1 auto paused";
	const EVT_CODE_LD_INIT_BACK_AUTO_RESUME = "Background initialization on virtual disk %1 auto resumed";
	//10 events for Foreground initialization
	const EVT_CODE_LD_INIT_FORE_START = "Foreground initialization on virtual disk %1 started";
	const EVT_CODE_LD_INIT_FORE_RESTART = "Foreground initialization on virtual disk %1 restarted";
	const EVT_CODE_LD_INIT_FORE_PAUSE = "Foreground initialization on virtual disk %1 paused";
	const EVT_CODE_LD_INIT_FORE_RESUME = "Foreground initialization on virtual disk %1 resumed";
	const EVT_CODE_LD_INIT_FORE_ABORT = "Foreground initialization on virtual disk %1 aborted";
	const EVT_CODE_LD_INIT_FORE_COMPLETE = "Foreground initialization on virtual disk %1 completed";
	const EVT_CODE_LD_INIT_FORE_PROGRESS = "Foreground initialization on virtual disk %1 is %2% done";
	const EVT_CODE_LD_INIT_FORE_ERROR = "Foreground initialization on virtual disk %1 failed";
	const EVT_CODE_LD_INIT_FORE_AUTO_PAUSED = "Foreground initialization on virtual disk %1 auto paused";
	const EVT_CODE_LD_INIT_FORE_AUTO_RESUME = "Foreground initialization on virtual disk %1 auto resumed";
	//10 events for Rebuild
	const EVT_CODE_LD_REBUILD_START = "Rebuild disk on virtual disk %1 started";
	const EVT_CODE_LD_REBUILD_RESTART = "Rebuild disk on virtual disk %1 restarted";
	const EVT_CODE_LD_REBUILD_PAUSE = "Rebuild disk on virtual disk %1 paused";
	const EVT_CODE_LD_REBUILD_RESUME = "Rebuild disk on virtual disk %1 resumed";
	const EVT_CODE_LD_REBUILD_ABORT = "Rebuild disk on virtual disk %1 aborted";
	const EVT_CODE_LD_REBUILD_COMPLETE = "Rebuild disk on virtual disk %1 completed";
	const EVT_CODE_LD_REBUILD_PROGRESS = "Rebuild disk on virtual disk %1 is %2% done";
	const EVT_CODE_LD_REBUILD_ERROR = "Rebuild disk on virtual disk %1 failed";
	const EVT_CODE_LD_REBUILD_AUTO_PAUSED = "Rebuild disk on virtual disk %1 auto paused";
	const EVT_CODE_LD_REBUILD_AUTO_RESUME = "Rebuild disk on virtual disk %1 auto resumed";
	//10 events for Migration
	const EVT_CODE_LD_MIGRATION_START = "Migration on virtual disk %1 started";
	const EVT_CODE_LD_MIGRATION_RESTART = "Migration on virtual disk %1 restarted";
	const EVT_CODE_LD_MIGRATION_PAUSE = "Migration on virtual disk %1 paused";
	const EVT_CODE_LD_MIGRATION_RESUME = "Migration on virtual disk %1 resumed";
	const EVT_CODE_LD_MIGRATION_ABORT = "Migration on virtual disk %1 aborted";
	const EVT_CODE_LD_MIGRATION_COMPLETE = "Migration on virtual disk %1 completed";
	const EVT_CODE_LD_MIGRATION_PROGRESS = "Migration on virtual disk %1 is %2% done";
	const EVT_CODE_LD_MIGRATION_ERROR = "Migration on virtual disk %1 failed";
	const EVT_CODE_LD_MIGRATION_AUTO_PAUSED = "Migration on virtual disk %1 is auto paused";
	const EVT_CODE_LD_MIGRATION_AUTO_RESUME = "Migration on virtual disk %1 is auto resumed";
	//10 events for Copy back
	const EVT_CODE_LD_COPYBACK_START = "Copy back on virtual disk %1 started";
	const EVT_CODE_LD_COPYBACK_RESTART = "Copy back on virtual disk %1 restarted";
	const EVT_CODE_LD_COPYBACK_PAUSE = "Copy back on virtual disk %1 paused";
	const EVT_CODE_LD_COPYBACK_RESUME = "Copy back on virtual disk %1 resumed";
	const EVT_CODE_LD_COPYBACK_ABORT = "Copy back on virtual disk %1 aborted";
	const EVT_CODE_LD_COPYBACK_COMPLETE = "Copy back on virtual disk %1 completed";
	const EVT_CODE_LD_COPYBACK_PROGRESS = "Copy back on virtual disk %1 is %2% done";
	const EVT_CODE_LD_COPYBACK_ERROR = "Copy back on virtual disk %1 failed";
	const EVT_CODE_LD_COPYBACK_AUTO_PAUSED = "Copy back on virtual disk %1 is auto paused";
	const EVT_CODE_LD_COPYBACK_AUTO_RESUME = "Copy back on virtual disk %1 is auto resumed";
	
	const EVT_CODE_LD_INCONSISTENT_LBA = "Consistency check on virtual disk %1 found inconsistent LBA %2 %3";
	//const EVT_CODE_LD_INCONSISTENT_LBA = "Check integrity on virtual disk %1 found inconsistent LBA. LBA.low=%3, LBA.high=%2";
	const EVT_Unknown_LD = "Unknown event %1 at virtual disk %2";
	
	//Array event
	const EVT_CODE_ARRAY_CREATE = "Array %1 is created";
	const EVT_CODE_ARRAY_DELETE = "Array %1 is deleted";
	const EVT_Unknown_ARRAY = "Unknown event %1 at array %2";

	//HD event
	const EVT_CODE_HD_OFFLINE = "Physical disk %1 is plugged out";
	const EVT_CODE_HD_ONLINE = "Physical disk %1 is plugged in";
	const EVT_CODE_HD_SETDOWN = "Physical disk %1 is set down";
	const EVT_CODE_HD_TIMEOUT = "Request to physical disk %1 is timed out";
	//const EVT_CODE_HD_RW_ERROR = "Physical disk %1 read write error LBA %2 %3";
	const EVT_CODE_HD_RW_ERROR = "Physical disk %1 has read write error";
	const EVT_CODE_HD_SMART = "Physical disk %1 S.M.A.R.T started";
	//const EVT_CODE_HD_ERROR_FIXED = "Physical disk %1 error being fixed LBA %2 %3";
	const EVT_CODE_HD_ERROR_FIXED = "Physical disk %1 error being fixed";
	const EVT_CODE_HD_ASSIGN_SPARE = "Physical disk %1 has been assigned as spare drive";
	const EVT_CODE_HD_REMOVE_SPARE = "Physical disk %1 has been unset as spare drive";
	const EVT_CODE_HD_SMART_THRESHOLD_OVER = "SMART has over threshold on physical disk %1";
	const EVT_CODE_HD_SMART_POLLING_FAIL = "SMART polling failed on physical disk %1";
	const EVT_CODE_BAD_BLOCK_TBL_80_FULL = "Bad block table on physical disk %1 is 80% full";
	const EVT_CODE_BAD_BLOCK_TBL_FULL = "Bad block table on physical disk %1 is full";
	const EVT_CODE_BAD_BLOCK_REASSIGNED = "Bad block reassigned on physical disk %1";
	const EVT_CODE_HD_CACHE_MODE_CHANGE = "Cache mode of physical disk %1 has been changed";	

	const EVT_Unknown_HD = "Unknown event %1 at physical disk %2";

	// Messages for Misc class  
	const EVT_CODE_MISC_GET_SHUTDOWN_CMD = "Shutdown command received from host";
	const EVT_CODE_MISC_PD_MISSING_FROM_CONFIG_AT_BOOT = "Physical disk missing from virtual disk %1 configuration at boot";
	const EVT_CODE_MISC_VD_MISSING_DRIVES = "Virtual disk %1 missing disk(s) and went offline at boot";
	const EVT_CODE_MISC_VD_MISSING_AT_BOOT = "Virtual disk %1 missing at boot";
	const EVT_CODE_MISC_PREVIOUS_CONFIG_MISSING_AT_BOOT = "Previous configuration completely missing at boot";
	const EVT_CODE_MISC_PD_TOO_SMALL_FOR_AUTOREBUILD = "Physical disk %1 too small to be used for auto-rebuild";
	const EVT_CODE_MISC_PD_TOO_SMALL_FOR_COPYBACK = "Physical disk %1 too small to be used for copy back";
	const EVT_CODE_MISC_CHANGE_SYNC_RATE = "Synchronization rate has been changed to %1%";
	const EVT_CODE_MISC_CHANGE_INIT_RATE = "Initialization rate has been changed to %1%";
	const EVT_CODE_MISC_CHANGE_REBUILD_RATE = "Rebuild rate has been changed to %1%";
	const EVT_CODE_MISC_CHANGE_MIGRATION_RATE = "Migration rate has been changed to %1%";
	const EVT_CODE_MISC_CHANGE_COPYBACK_RATE = "Copy Back rate has been changed to %1%";
	const EVT_CODE_MISC_CHANGE_MP_RATE = "Media patrol rate has been changed to %1%";
	
	const EVT_CODE_MISC_CONFIG_CLEARED = "Configuration cleared";
	const EVT_CODE_MISC_CHANGE_BACK_ACTIVITY_RATE = "Background activity rate changed to %1%";
	const EVT_CODE_MISC_MUTLI_BIT_ECC_ERR = "Multi-bit ECC error: count = %1, address = 0x%2, module ID = %3";
	const EVT_CODE_MISC_SINGLE_BIT_ECC_ERR = "Single-bit ECC error: count = %1";
	const EVT_CODE_MISC_FATAL_FW_ERR = "Fatal firmware error: %1";
	const EVT_CODE_MISC_FACTORY_DEFAULTS_RESTORED = "Factory defaults restored";
	const EVT_CODE_MISC_GET_HIBER_CMD = "Hibernation command received from host";
	const EVT_CODE_MISC_TIME_ESTABLISHED = "Time established as %1; (%2 seconds since power on)";
	const EVT_CODE_MISC_USER_ENTERED_DEBUGGER = "User entered firmware debugger";  
	
	    
	const EVT_CODE_SAS_LOOP_DETECTED = "SAS Topology error: Loop detected";                                                                    
	const EVT_CODE_SAS_UNADDR_DEVICE = "SAS Topology error: Unaddressable device";                                                              
	const EVT_CODE_SAS_MULTIPORT_SAME_ADDR = "SAS Topology error: Multiple ports to the same SAS address";                                                            
	const EVT_CODE_SAS_EXPANDER_ERR = "SAS Topology error: Expander error";                                                                            
	const EVT_CODE_SAS_SMP_TIMEOUT = "SAS Topology error: SMP time out";
	const EVT_CODE_SAS_OUT_OF_ROUTE_ENTRIES = "SAS Topology error: Out of route entries";
	const EVT_CODE_SAS_INDEX_NOT_FOUND = "SAS Topology error: Index not found";
	const EVT_CODE_SAS_SMP_FUNC_FAILED = "SAS Topology error: SMP function failed";
	const EVT_CODE_SAS_SMP_CRC_ERR = "SAS Topology error: SMP CRC error";
	const EVT_CODE_SAS_MULTI_SUBTRACTIVE = "SAS Topology error: Multiple subtractive";
	const EVT_CODE_SAS_TABEL_TO_TABLE = "SAS Topology error: Table to Table";
	const EVT_CODE_SAS_MULTI_PATHS = "SAS Topology error: Multiple paths";
	const EVT_CODE_SAS_WIDE_PORT_LOST_LINK_ON_PHY = "SAS wide port %1 lost link on PHY %2";
	const EVT_CODE_SAS_WIDE_PORT_REST_LINK_ON_PHY = "SAS wide port %1 restored link on PHY %2";
	const EVT_CODE_SAS_PHY_EXCEED_ERR_RATE = "SAS port %1, PHY %2 has exceeded the allowed error rate";
	const EVT_CODE_SAS_SATA_MIX_NOT_SUPPORTED = "SAS/SATA mixing not supported in enclosure: physical disk %1 disabled";
	                                                                 
	const EVT_CODE_ENCL_SES_DISCOVERED = "Enclosure(SES) discovered on %1";
	const EVT_CODE_ENCL_SAFTE_DISCOVERED = " Enclosure(SAFTE) discovered on %1";
	const EVT_CODE_ENCL_COMMUNICATION_LOST = " Enclosure %1 communication lost";
	const EVT_CODE_ENCL_COMMUNICATION_RESTORED = "Enclosure %1 communication restored";
	const EVT_CODE_ENCL_FAN_FAILED = "Enclosure %1 fan %2 failed";
	const EVT_CODE_ENCL_FAN_INSERTED = "Enclosure %1 fan %2 inserted";
	const EVT_CODE_ENCL_FAN_REMOVED = "Enclosure %1 fan %2 removed";
	const EVT_CODE_ENCL_PS_FAILED = "Enclosure %1 power supply %2 failed";
	const EVT_CODE_ENCL_PS_INSERTED = "Enclosure %1 power supply %2 inserted";
	const EVT_CODE_ENCL_PS_REMOVED = "Enclosure %1 power supply %2 removed";
	const EVT_CODE_ENCL_SIM_FAILED = "Enclosure %1 SIM %2 failed";
	const EVT_CODE_ENCL_SIM_INSERTED = "Enclosure %1 SIM %2 inserted";
	const EVT_CODE_ENCL_SIM_REMOVED = "Enclosure %1 SIM %2 removed";
	const EVT_CODE_ENCL_TEMP_SENSOR_BELOW_WARNING = " Enclosure %1 temperature sensor %2 below warning threshold";
	const EVT_CODE_ENCL_TEMP_SENSOR_BELOW_ERR = "Enclosure %1 temperature sensor %2 below error threshold";
	const EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_WARNING = "Enclosure %1 temperature sensor %2 above warning threshold";
	const EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_ERR = "Enclosure %1 temperature sensor %2 above error threshold";
	const EVT_CODE_ENCL_SHUTDOWN = "Enclosure %1 shutdown";
	const EVT_CODE_ENCL_NOT_SUPPORTED = "Enclosure %1 not supported; too many enclosures connected to port";
	const EVT_CODE_ENCL_FW_MISMATCH	 = "Enclosure %1 firmware mismatch";
	const EVT_CODE_ENCL_SENSOR_BAD = "Enclosure %1 sensor %2 bad";
	const EVT_CODE_ENCL_PHY_BAD = "Enclosure %1 phy %2 bad";
	const EVT_CODE_ENCL_IS_UNSTABLE = "Enclosure %1 is unstable";
	const EVT_CODE_ENCL_HW_ERR = " Enclosure %1 hardware error";
	const EVT_CODE_ENCL_NOT_RESPONDING = "Enclosure %1 not responding";
	const EVT_CODE_ENCL_HOTPLUG_DETECTED = "Enclosure(SES) hotplug on %1 was detected, but is not supported";
	const EVT_CODE_ENCL_PS_SWITCHED_OFF = "Enclosure %1 Power supply %2 switched off";
	const EVT_CODE_ENCL_PS_SWITCHED_ON = "Enclosure %1 Power supply %2 switched on";
	const EVT_CODE_ENCL_PS_CABLE_REMOVED = "Enclosure %1 Power supply %2 cable removed";
	const EVT_CODE_ENCL_PS_CABLE_INSERTED = "Enclosure %1 Power supply %2 cable inserted";
	const EVT_CODE_ENCL_FAN_RETURN_TO_NORMAL = "Enclosure %1 Fan %1 returned to normal";
	const EVT_CODE_ENCL_TEMP_RETURN_TO_NORMAL = "Enclosure %1 Temperature %2 returned to normal";
	const EVT_CODE_ENCL_FW_DWLD_IN_PRGS = "Enclosure %1 Firmware download in progress";
	const EVT_CODE_ENCL_FW_DWLD_FAILED = "Enclosure %1 Firmware download failed";
	const EVT_CODE_ENCL_TEMP_SENSOR_DIFF_DETECTED = "Enclosure %1 Temperature sensor %2 differential detected";
	const EVT_CODE_ENCL_FAN_SPEED_CHANGED = "Enclosure %1 fan %2 speed changed";
	                                                                                              
	const EVT_CODE_BAT_PRESENT = "Battery present";
	const EVT_CODE_BAT_NOT_PRESENT = "Battery not present";
	const EVT_CODE_BAT_NEW_BAT_DETECTED = "New battery detected";
	const EVT_CODE_BAT_NEED_REPLACE = "Battery needs to be replaced";
	const EVT_CODE_BAT_REPLACED = "Battery has been replaced";
	const EVT_CODE_BAT_REMOVED = "Battery is removed";
	const EVT_CODE_BAT_RELEARN_STARTED = "Battery relearn started";
	const EVT_CODE_BAT_RELEARN_IN_PGRS = "Battery relearn in progress";
	const EVT_CODE_BAT_RELEARN_COMPLETED = "Battery relearn completed";
	const EVT_CODE_BAT_RELEARN_TIMED_OUT = "Battery relearn timed out";
	const EVT_CODE_BAT_RELEARN_PENDING = "Battery relearn pending: Battery is under charge";
	const EVT_CODE_BAT_RELEARN_POSTPONED = "Battery relearn postponed";
	const EVT_CODE_BAT_START_IN_4_DAYS = "Battery relearn will start in 4 days";
	const EVT_CODE_BAT_START_IN_2_DAYS = "Battery relearn will start in 2 days";
	const EVT_CODE_BAT_START_IN_1_DAY = "Battery relearn will start in 1 day";
	const EVT_CODE_BAT_START_IN_5_HOURS = "Battery relearn will start in 5 hours";
	const EVT_CODE_BAT_DISCHARGING = " Battery is discharging";
	const EVT_CODE_BAT_STARTED_CHARGING	 = "Battery started charging";
	const EVT_CODE_BAT_CHARGE_CMPLT = "Battery completed charging";
	const EVT_CODE_BAT_CHARGER_PROBLEM_DETECTED = "Battery/charger problems detected";
	const EVT_CODE_BAT_CAPACITY_BELOW_THRESHOLD = "Battery capacity is below threshold";
	const EVT_CODE_BAT_CAPACITY_ABOVE_THRESHOLD = "Battery capacity is above threshold";
	const EVT_CODE_BAT_TEMP_IS_LOW = "Battery temperature is low";
	const EVT_CODE_BAT_TEMP_IS_NORMAL = "Battery temperature back to normal";
	const EVT_CODE_BAT_TEMP_IS_HIGH = "Battery temperature is high";
	const EVT_CODE_BAT_VOLTAGE_LOW = "Battery voltage is low";
	const EVT_CODE_BAT_VOLTAGE_NORMAL = "Battery voltage back to normal";
	const EVT_CODE_BAT_VOLTAGE_HIGH = "Battery voltage is high";
	const EVT_CODE_BAT_FORCE_WRITE_THROUGH = "Battery status is abnormal, VDs with auto-cache are now in write through mode";
	const EVT_CODE_BAT_SAFE_TO_USE_WRITE_BACK = "Battery status back to normal, VDs with auto-cache are now in write back mode";
	                                                             
	const EVT_CODE_FLASH_DWLDED_IMAGE_CORRUPTED = "Flash downloaded image corrupt";
	const EVT_CODE_FLASH_ERASE_ERR = "Flash erase error";
	const EVT_CODE_FLASH_ERASE_TIMEOUT = "Flash timeout during erase";
	const EVT_CODE_FLASH_FLASH_ERR = "Flash error";
	const EVT_CODE_FLASHING_IMAGE = "Flashing image: %1";
	const EVT_CODE_FLASHING_NEW_IMAGE_DONE = "Flash of new firmware images complete";
	const EVT_CODE_FLASH_PROGRAMMING_ERR = "Flash programming error";
	const EVT_CODE_FLASH_PROGRAMMING_TIMEOUT = "Flash timeout during programming";
	const EVT_CODE_FLASH_UNKNOWN_CHIP_TYPE = "Flash chip type unknown";
	const EVT_CODE_FLASH_UNKNOWN_CMD_SET = "Flash command set unknown";
	const EVT_CODE_FLASH_VERIFY_FAILURE = "Flash verify failure";
	const EVT_CODE_NVRAM_CORRUPT = "NVRAM is corrupt; reinitializing";
	const EVT_CODE_NVRAM_MISMACTH_OCCURED = "NVRAM mismatch occured";
	                                                                                                        
	const EVT_CODE_CACHE_NOT_RECV_FROM_TBBU = "Unable to recover cache data from TBBU";
	const EVT_CODE_CACHE_RECVD_FROM_TBBU = "Cache data recovered from TBBU successfully";
	const EVT_CODE_CACHE_CTRLER_CACHE_DISCARDED = "Controller cache discarded due to memory/battery problems";
	const EVT_CODE_CACHE_FAIL_RECV_DUETO_MISMATCH = "Unable to recover cache data due to configuration mismatch";
	const EVT_CODE_CACHE_DIRTY_DATA_DISCARDED = "Dirty cache data discarded by user";
	const EVT_CODE_CACHE_FLUSH_RATE_CHANGED = "Flush rate changed to %1 seconds";
		                                                                                       
	const EVT_CODE_MISC_FORMAT_COMPLETE	 = "Format complete on %1";
	const EVT_CODE_MISC_FORMAT_STARTED = "Format started on %1";
	const EVT_CODE_MISC_REASSIGN_WRITE_OP = "Reassign write operation on %1 is %2";
	const EVT_CODE_MISC_UNEXPECTED_SENSE = "Unexpected sense: %1, CDB%2, Sense: %3";
	const EVT_CODE_MISC_REPLACED_MISSING = "Replaced missing as %1 on array %2 row %3";
	const EVT_CODE_MISC_NOT_A_CERTIFIED_DRIVE = "%1 is not a certificated disk";
	
	//HD Media Patrol
	const EVT_CODE_HD_MP_START = "Media Patrol on physical disk %1 started";
	const EVT_CODE_HD_MP_RESTART = "Media Patrol on physical disk %1 restarted";
	const EVT_CODE_HD_MP_PAUSE = "Media Patrol on physical disk %1 paused";
	const EVT_CODE_HD_MP_RESUME = "Media Patrol on physical disk %1 resumed";
	const EVT_CODE_HD_MP_ABORT = "Media Patrol on physical disk %1 aborted";
	const EVT_CODE_HD_MP_COMPLETE = "Media Patrol on physical disk %1 completed";
	const EVT_CODE_HD_MP_PROGRESS = "Media Patrol on physical disk %1 is %2% done";
	const EVT_CODE_HD_MP_ERROR = "Media Patrol on physical disk %1 failed";
	const EVT_CODE_HD_MP_AUTO_PAUSED = "Media Patrol on physical disk %1 is auto paused";
	const EVT_CODE_HD_MP_AUTO_RESUME = "Media Patrol on physical disk %1 is auto resumed";
	
	//sence code related
	const EVT_CODE_HD_SC_ERROR = "Command [0x%2] on physical disk %1 failed. Sense key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_RCT_ADD = "Bad Sector is detected on disk %1 at LBA(0x%2%3), count=%4, flag=0x%5";
	const EVT_CODE_HD_RCT_REMOVE = "Bad Sector is fixed on disk %1 at LBA(0x%2%3), count=%4, flag=0x%5";
	/*const EVT_CODE_HD_SC_NO_SENSE = "NO SENSE on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_RECOVERED_ERROR = "RECOVERED ERROR on device %1, CDB[0]=0x%2. Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
    const EVT_CODE_HD_SC_NOT_READY = "NOT READY on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
    const EVT_CODE_HD_SC_MEDIUM_ERROR = "MEDIUM ERROR on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_HARDWARE_ERROR = "HARDWARE ERROR on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_ILLEGAL_REQUEST = "ILLEGAL REQUEST on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_UNIT_ATTENTION = "UNIT ATTENTION on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_DATA_PROTECT = "DATA PROTECT on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_BLANK_CHECK = "BLANK CHECK on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_VENDOR_SPECIFIC = "VENDOR SPECIFIC on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_COPY_ABORTED = "COPY ABORTED on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_ABORTED_COMMAND = "ABORTED COMMAND on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_VOLUME_OVERFLOW = "VOLUME OVERFLOW on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	const EVT_CODE_HD_SC_MISCOMPARE = "MISCOMPARE on device %1, CDB[0]=0x%2, Sense Key=0x%3, ASC=0x%4, ASCQ=0x%5";
	*/
	const EVT_CODE_HD_SETFREE = "Physical disk %1 has been set as free disk";
	
	const EVT_CODE_MDD_ERROR = "MDD error";
	const EVT_CODE_EXPANDER_PLUG_IN = "Expander %1 is plugged in";
	const EVT_CODE_EXPANDER_PLUG_OUT = "Expander %1 is plugged out";
	
	const EVT_Unknown = "Unknown event class %1, code %2";
	
	public static function getEventStr($EventCode)
	{
		/*the following code commented will output warning if no $EventCode found*/
		/*
		$str = constant("self::$EventCode");
		if ($str) {
			return self::EVT_Unknown;
		}
		return $str;
		*/
		switch ($EventCode)
		{
			case "EVT_CODE_EVT_ERR" : return self::EVT_CODE_EVT_ERR;
			case "EVT_CODE_SMART_FROM_OFF_TO_ON" : return self::EVT_CODE_SMART_FROM_OFF_TO_ON;
			case "EVT_CODE_SMART_FROM_ON_TO_OFF" : return self::EVT_CODE_SMART_FROM_ON_TO_OFF;
			case "EVT_CODE_ALARM_TURN_ON" : return self::EVT_CODE_ALARM_TURN_ON;
			case "EVT_CODE_ALARM_TURN_OFF" : return self::EVT_CODE_ALARM_TURN_OFF;
			case "EVT_CODE_AUTO_REBUILD_ON" : return self::EVT_CODE_AUTO_REBUILD_ON;
			case "EVT_CODE_AUTO_REBUILD_OFF" : return self::EVT_CODE_AUTO_REBUILD_OFF;
			case "EVT_CODE_HD_MP_RATE_CHANGE" : return self::EVT_CODE_HD_MP_RATE_CHANGE;
			case "EVT_CODE_COPY_BACK_ON": return self::EVT_CODE_COPY_BACK_ON;
			case "EVT_CODE_COPY_BACK_OFF": return self::EVT_CODE_COPY_BACK_OFF;
			case "EVT_CODE_ADAPTER_FOUND": return self::EVT_CODE_ADAPTER_FOUND;
			case "EVT_CODE_BBU_ECCERROR": return self::EVT_CODE_BBU_ECCERROR;
			case "EVT_CODE_ADAPTER_BBU_COUNT": return self::EVT_CODE_ADAPTER_BBU_COUNT;
			case "EVT_CODE_ADAPTER_BBU_START": return self::EVT_CODE_ADAPTER_BBU_START;
			case "EVT_CODE_ADAPTER_BBU_FINISH": return self::EVT_CODE_ADAPTER_BBU_FINISH;
			case "EVT_CODE_PAGE_ECC_ERROR": return self::EVT_CODE_PAGE_ECC_ERROR;
			case "EVT_CODE_ADAPTER_FOUND_NO_SERIAL": return self::EVT_CODE_ADAPTER_FOUND_NO_SERIAL;
						
			case "EVT_Unknown_Adpt" : return self::EVT_Unknown_Adpt;
			case "EVT_CODE_LD_OFFLINE" : return self::EVT_CODE_LD_OFFLINE;
			case "EVT_CODE_LD_ONLINE" : return self::EVT_CODE_LD_ONLINE;
			case "EVT_CODE_LD_CREATE" : return self::EVT_CODE_LD_CREATE;
			case "EVT_CODE_LD_DELETE" : return self::EVT_CODE_LD_DELETE;
			case "EVT_CODE_LD_DEGRADE" : return self::EVT_CODE_LD_DEGRADE;
			case "EVT_CODE_LD_PARTIALLYOPTIMAL": return self::EVT_CODE_LD_PARTIALLYOPTIMAL;
			case "EVT_CODE_LD_CRITICAL" : return self::EVT_CODE_LD_CRITICAL;
			case "EVT_CODE_LD_CACHE_MODE_CHANGE" : return self::EVT_CODE_LD_CACHE_MODE_CHANGE;
			case "EVT_CODE_LD_FIXED" : return self::EVT_CODE_LD_FIXED;
			case "EVT_CODE_LD_FOUND_ERROR" : return self::EVT_CODE_LD_FOUND_ERROR;
			case "EVT_CODE_LD_IMPORTED" : return self::EVT_CODE_LD_IMPORTED;
			case "EVT_CODE_LD_CHECK_START" : return self::EVT_CODE_LD_CHECK_START;
			case "EVT_CODE_LD_CHECK_RESTART" : return self::EVT_CODE_LD_CHECK_RESTART;
			case "EVT_CODE_LD_CHECK_PAUSE" : return self::EVT_CODE_LD_CHECK_PAUSE;
			case "EVT_CODE_LD_CHECK_RESUME" : return self::EVT_CODE_LD_CHECK_RESUME;
			case "EVT_CODE_LD_CHECK_ABORT" : return self::EVT_CODE_LD_CHECK_ABORT;
			case "EVT_CODE_LD_CHECK_COMPLETE" : return self::EVT_CODE_LD_CHECK_COMPLETE;
			case "EVT_CODE_LD_CHECK_PROGRESS" : return self::EVT_CODE_LD_CHECK_PROGRESS;
			case "EVT_CODE_LD_CHECK_ERROR" : return self::EVT_CODE_LD_CHECK_ERROR;
			case "EVT_CODE_LD_CHECK_AUTO_PAUSED" : return self::EVT_CODE_LD_CHECK_AUTO_PAUSED;
			case "EVT_CODE_LD_CHECK_AUTO_RESUME" : return self::EVT_CODE_LD_CHECK_AUTO_RESUME;
			case "EVT_CODE_LD_FIX_START" : return self::EVT_CODE_LD_FIX_START;
			case "EVT_CODE_LD_FIX_RESTART" : return self::EVT_CODE_LD_FIX_RESTART;
			case "EVT_CODE_LD_FIX_PAUSE" : return self::EVT_CODE_LD_FIX_PAUSE;
			case "EVT_CODE_LD_FIX_RESUME" : return self::EVT_CODE_LD_FIX_RESUME;
			case "EVT_CODE_LD_FIX_ABORT" : return self::EVT_CODE_LD_FIX_ABORT;
			case "EVT_CODE_LD_FIX_COMPLETE" : return self::EVT_CODE_LD_FIX_COMPLETE;
			case "EVT_CODE_LD_FIX_PROGRESS" : return self::EVT_CODE_LD_FIX_PROGRESS;
			case "EVT_CODE_LD_FIX_ERROR" : return self::EVT_CODE_LD_FIX_ERROR;
			case "EVT_CODE_LD_FIX_AUTO_PAUSED" : return self::EVT_CODE_LD_FIX_AUTO_PAUSED;
			case "EVT_CODE_LD_FIX_AUTO_RESUME" : return self::EVT_CODE_LD_FIX_AUTO_RESUME;
			case "EVT_CODE_LD_INIT_QUICK_START" : return self::EVT_CODE_LD_INIT_QUICK_START;
			case "EVT_CODE_LD_INIT_QUICK_RESTART" : return self::EVT_CODE_LD_INIT_QUICK_RESTART;
			case "EVT_CODE_LD_INIT_QUICK_PAUSE" : return self::EVT_CODE_LD_INIT_QUICK_PAUSE;
			case "EVT_CODE_LD_INIT_QUICK_RESUME" : return self::EVT_CODE_LD_INIT_QUICK_RESUME;
			case "EVT_CODE_LD_INIT_QUICK_ABORT" : return self::EVT_CODE_LD_INIT_QUICK_ABORT;
			case "EVT_CODE_LD_INIT_QUICK_COMPLETE" : return self::EVT_CODE_LD_INIT_QUICK_COMPLETE;
			case "EVT_CODE_LD_INIT_QUICK_PROGRESS" : return self::EVT_CODE_LD_INIT_QUICK_PROGRESS;
			case "EVT_CODE_LD_INIT_QUICK_ERROR" : return self::EVT_CODE_LD_INIT_QUICK_ERROR;
			case "EVT_CODE_LD_INIT_QUICK_AUTO_PAUSED" : return self::EVT_CODE_LD_INIT_QUICK_AUTO_PAUSED;
			case "EVT_CODE_LD_INIT_QUICK_AUTO_RESUME" : return self::EVT_CODE_LD_INIT_QUICK_AUTO_RESUME;
			case "EVT_CODE_LD_INIT_BACK_START" : return self::EVT_CODE_LD_INIT_BACK_START;
			case "EVT_CODE_LD_INIT_BACK_RESTART" : return self::EVT_CODE_LD_INIT_BACK_RESTART;
			case "EVT_CODE_LD_INIT_BACK_PAUSE" : return self::EVT_CODE_LD_INIT_BACK_PAUSE;
			case "EVT_CODE_LD_INIT_BACK_RESUME" : return self::EVT_CODE_LD_INIT_BACK_RESUME;
			case "EVT_CODE_LD_INIT_BACK_ABORT" : return self::EVT_CODE_LD_INIT_BACK_ABORT;
			case "EVT_CODE_LD_INIT_BACK_COMPLETE" : return self::EVT_CODE_LD_INIT_BACK_COMPLETE;
			case "EVT_CODE_LD_INIT_BACK_PROGRESS" : return self::EVT_CODE_LD_INIT_BACK_PROGRESS;
			case "EVT_CODE_LD_INIT_BACK_ERROR" : return self::EVT_CODE_LD_INIT_BACK_ERROR;
			case "EVT_CODE_LD_INIT_BACK_AUTO_PAUSED" : return self::EVT_CODE_LD_INIT_BACK_AUTO_PAUSED;
			case "EVT_CODE_LD_INIT_BACK_AUTO_RESUME" : return self::EVT_CODE_LD_INIT_BACK_AUTO_RESUME;
			case "EVT_CODE_LD_INIT_FORE_START" : return self::EVT_CODE_LD_INIT_FORE_START;
			case "EVT_CODE_LD_INIT_FORE_RESTART" : return self::EVT_CODE_LD_INIT_FORE_RESTART;
			case "EVT_CODE_LD_INIT_FORE_PAUSE" : return self::EVT_CODE_LD_INIT_FORE_PAUSE;
			case "EVT_CODE_LD_INIT_FORE_RESUME" : return self::EVT_CODE_LD_INIT_FORE_RESUME;
			case "EVT_CODE_LD_INIT_FORE_ABORT" : return self::EVT_CODE_LD_INIT_FORE_ABORT;
			case "EVT_CODE_LD_INIT_FORE_COMPLETE" : return self::EVT_CODE_LD_INIT_FORE_COMPLETE;
			case "EVT_CODE_LD_INIT_FORE_PROGRESS" : return self::EVT_CODE_LD_INIT_FORE_PROGRESS;
			case "EVT_CODE_LD_INIT_FORE_ERROR" : return self::EVT_CODE_LD_INIT_FORE_ERROR;
			case "EVT_CODE_LD_INIT_FORE_AUTO_PAUSED" : return self::EVT_CODE_LD_INIT_FORE_AUTO_PAUSED;
			case "EVT_CODE_LD_INIT_FORE_AUTO_RESUME" : return self::EVT_CODE_LD_INIT_FORE_AUTO_RESUME;
			case "EVT_CODE_LD_REBUILD_START" : return self::EVT_CODE_LD_REBUILD_START;
			case "EVT_CODE_LD_REBUILD_RESTART" : return self::EVT_CODE_LD_REBUILD_RESTART;
			case "EVT_CODE_LD_REBUILD_PAUSE" : return self::EVT_CODE_LD_REBUILD_PAUSE;
			case "EVT_CODE_LD_REBUILD_RESUME" : return self::EVT_CODE_LD_REBUILD_RESUME;
			case "EVT_CODE_LD_REBUILD_ABORT" : return self::EVT_CODE_LD_REBUILD_ABORT;
			case "EVT_CODE_LD_REBUILD_COMPLETE" : return self::EVT_CODE_LD_REBUILD_COMPLETE;
			case "EVT_CODE_LD_REBUILD_PROGRESS" : return self::EVT_CODE_LD_REBUILD_PROGRESS;
			case "EVT_CODE_LD_REBUILD_ERROR" : return self::EVT_CODE_LD_REBUILD_ERROR;
			case "EVT_CODE_LD_REBUILD_AUTO_PAUSED" : return self::EVT_CODE_LD_REBUILD_AUTO_PAUSED;
			case "EVT_CODE_LD_REBUILD_AUTO_RESUME" : return self::EVT_CODE_LD_REBUILD_AUTO_RESUME;
			case "EVT_CODE_LD_MIGRATION_START" : return self::EVT_CODE_LD_MIGRATION_START;
			case "EVT_CODE_LD_MIGRATION_RESTART" : return self::EVT_CODE_LD_MIGRATION_RESTART;
			case "EVT_CODE_LD_MIGRATION_PAUSE" : return self::EVT_CODE_LD_MIGRATION_PAUSE;
			case "EVT_CODE_LD_MIGRATION_RESUME" : return self::EVT_CODE_LD_MIGRATION_RESUME;
			case "EVT_CODE_LD_MIGRATION_ABORT" : return self::EVT_CODE_LD_MIGRATION_ABORT;
			case "EVT_CODE_LD_MIGRATION_COMPLETE" : return self::EVT_CODE_LD_MIGRATION_COMPLETE;
			case "EVT_CODE_LD_MIGRATION_PROGRESS" : return self::EVT_CODE_LD_MIGRATION_PROGRESS;
			case "EVT_CODE_LD_MIGRATION_ERROR" : return self::EVT_CODE_LD_MIGRATION_ERROR;
			case "EVT_CODE_LD_MIGRATION_AUTO_PAUSED" : return self::EVT_CODE_LD_MIGRATION_AUTO_PAUSED;
			case "EVT_CODE_LD_MIGRATION_AUTO_RESUME" : return self::EVT_CODE_LD_MIGRATION_AUTO_RESUME;
			
			case "EVT_CODE_LD_COPYBACK_START": return self::EVT_CODE_LD_COPYBACK_START;
			case "EVT_CODE_LD_COPYBACK_RESTART": return self::EVT_CODE_LD_COPYBACK_RESTART;
			case "EVT_CODE_LD_COPYBACK_PAUSE": return self::EVT_CODE_LD_COPYBACK_PAUSE;
			case "EVT_CODE_LD_COPYBACK_RESUME": return self::EVT_CODE_LD_COPYBACK_RESUME;
			case "EVT_CODE_LD_COPYBACK_ABORT": return self::EVT_CODE_LD_COPYBACK_ABORT;
			case "EVT_CODE_LD_COPYBACK_COMPLETE": return self::EVT_CODE_LD_COPYBACK_COMPLETE;
			case "EVT_CODE_LD_COPYBACK_PROGRESS": return self::EVT_CODE_LD_COPYBACK_PROGRESS;
			case "EVT_CODE_LD_COPYBACK_ERROR": return self::EVT_CODE_LD_COPYBACK_ERROR;
			case "EVT_CODE_LD_COPYBACK_AUTO_PAUSED": return self::EVT_CODE_LD_COPYBACK_AUTO_PAUSED;
			case "EVT_CODE_LD_COPYBACK_AUTO_RESUME": return self::EVT_CODE_LD_COPYBACK_AUTO_RESUME;
			
			case "EVT_CODE_LD_INCONSISTENT_LBA" : return self::EVT_CODE_LD_INCONSISTENT_LBA;
			case "EVT_Unknown_LD" : return self::EVT_Unknown_LD;
			
			case "EVT_CODE_ARRAY_CREATE" : return self::EVT_CODE_ARRAY_CREATE;
			case "EVT_CODE_ARRAY_DELETE" : return self::EVT_CODE_ARRAY_DELETE;
			case "EVT_Unknown_ARRAY" : return self::EVT_Unknown_ARRAY;

			case "EVT_CODE_HD_OFFLINE" : return self::EVT_CODE_HD_OFFLINE;
			case "EVT_CODE_HD_ONLINE" : return self::EVT_CODE_HD_ONLINE;
			case "EVT_CODE_HD_SETDOWN" : return self::EVT_CODE_HD_SETDOWN;
			case "EVT_CODE_HD_TIMEOUT" : return self::EVT_CODE_HD_TIMEOUT;
			case "EVT_CODE_HD_RW_ERROR" : return self::EVT_CODE_HD_RW_ERROR;
			case "EVT_CODE_HD_SMART" : return self::EVT_CODE_HD_SMART;
			case "EVT_CODE_HD_ERROR_FIXED" : return self::EVT_CODE_HD_ERROR_FIXED;
			case "EVT_CODE_HD_ASSIGN_SPARE" : return self::EVT_CODE_HD_ASSIGN_SPARE;
			case "EVT_CODE_HD_REMOVE_SPARE" : return self::EVT_CODE_HD_REMOVE_SPARE;
			case "EVT_CODE_HD_SMART_THRESHOLD_OVER" : return self::EVT_CODE_HD_SMART_THRESHOLD_OVER;			
			case "EVT_CODE_HD_SMART_POLLING_FAIL" : return self::EVT_CODE_HD_SMART_POLLING_FAIL;
			case "EVT_CODE_BAD_BLOCK_TBL_80_FULL" : return self::EVT_CODE_BAD_BLOCK_TBL_80_FULL;
			case "EVT_CODE_BAD_BLOCK_TBL_FULL" : return self::EVT_CODE_BAD_BLOCK_TBL_FULL;
			case "EVT_CODE_BAD_BLOCK_REASSIGNED" : return self::EVT_CODE_BAD_BLOCK_REASSIGNED;
			case "EVT_CODE_HD_CACHE_MODE_CHANGE" : return self::EVT_CODE_HD_CACHE_MODE_CHANGE;
			case "EVT_Unknown_HD" : return self::EVT_Unknown_HD;
			
			
			case "EVT_CODE_MISC_GET_SHUTDOWN_CMD" : return self::EVT_CODE_MISC_GET_SHUTDOWN_CMD;
			case "EVT_CODE_MISC_PD_MISSING_FROM_CONFIG_AT_BOOT" : return self::EVT_CODE_MISC_PD_MISSING_FROM_CONFIG_AT_BOOT;
			case "EVT_CODE_MISC_VD_MISSING_DRIVES" : return self::EVT_CODE_MISC_VD_MISSING_DRIVES;
			case "EVT_CODE_MISC_VD_MISSING_AT_BOOT" : return self::EVT_CODE_MISC_VD_MISSING_AT_BOOT;
			case "EVT_CODE_MISC_PREVIOUS_CONFIG_MISSING_AT_BOOT" : return self::EVT_CODE_MISC_PREVIOUS_CONFIG_MISSING_AT_BOOT;
			case "EVT_CODE_MISC_PD_TOO_SMALL_FOR_AUTOREBUILD" : return self::EVT_CODE_MISC_PD_TOO_SMALL_FOR_AUTOREBUILD;
			case "EVT_CODE_MISC_PD_TOO_SMALL_FOR_COPYBACK": return self::EVT_CODE_MISC_PD_TOO_SMALL_FOR_COPYBACK;
			case "EVT_CODE_MISC_CHANGE_SYNC_RATE": return self::EVT_CODE_MISC_CHANGE_SYNC_RATE;
			case "EVT_CODE_MISC_CHANGE_INIT_RATE": return self::EVT_CODE_MISC_CHANGE_INIT_RATE;
			case "EVT_CODE_MISC_CHANGE_REBUILD_RATE": return self::EVT_CODE_MISC_CHANGE_REBUILD_RATE;
			case "EVT_CODE_MISC_CHANGE_MIGRATION_RATE": return self::EVT_CODE_MISC_CHANGE_MIGRATION_RATE;
			case "EVT_CODE_MISC_CHANGE_COPYBACK_RATE": return self::EVT_CODE_MISC_CHANGE_COPYBACK_RATE;
			case "EVT_CODE_MISC_CHANGE_MP_RATE": return self::EVT_CODE_MISC_CHANGE_MP_RATE;
			case "EVT_CODE_MISC_MUTLI_BIT_ECC_ERR": return self::EVT_CODE_MISC_MUTLI_BIT_ECC_ERR;
			case "EVT_CODE_MISC_SINGLE_BIT_ECC_ERR": return self::EVT_CODE_MISC_SINGLE_BIT_ECC_ERR;
						
			case "EVT_CODE_MISC_CONFIG_CLEARED" : return self::EVT_CODE_MISC_CONFIG_CLEARED;
			case "EVT_CODE_MISC_CHANGE_BACK_ACTIVITY_RATE" : return self::EVT_CODE_MISC_CHANGE_BACK_ACTIVITY_RATE;
			case "EVT_CODE_MISC_FATAL_FW_ERR" : return self::EVT_CODE_MISC_FATAL_FW_ERR;
			case "EVT_CODE_MISC_FACTORY_DEFAULTS_RESTORED" : return self::EVT_CODE_MISC_FACTORY_DEFAULTS_RESTORED;
			case "EVT_CODE_MISC_GET_HIBER_CMD" : return self::EVT_CODE_MISC_GET_HIBER_CMD;
			case "EVT_CODE_MISC_TIME_ESTABLISHED" : return self::EVT_CODE_MISC_TIME_ESTABLISHED;
			case "EVT_CODE_MISC_USER_ENTERED_DEBUGGER" : return self::EVT_CODE_MISC_USER_ENTERED_DEBUGGER;
			
			case "EVT_CODE_SAS_LOOP_DETECTED" : return self::EVT_CODE_SAS_LOOP_DETECTED;
			case "EVT_CODE_SAS_UNADDR_DEVICE" : return self::EVT_CODE_SAS_UNADDR_DEVICE;
			case "EVT_CODE_SAS_MULTIPORT_SAME_ADDR" : return self::EVT_CODE_SAS_MULTIPORT_SAME_ADDR;
			case "EVT_CODE_SAS_EXPANDER_ERR" : return self::EVT_CODE_SAS_EXPANDER_ERR;
			case "EVT_CODE_SAS_SMP_TIMEOUT" : return self::EVT_CODE_SAS_SMP_TIMEOUT;
			case "EVT_CODE_SAS_OUT_OF_ROUTE_ENTRIES" : return self::EVT_CODE_SAS_OUT_OF_ROUTE_ENTRIES;
			case "EVT_CODE_SAS_INDEX_NOT_FOUND" : return self::EVT_CODE_SAS_INDEX_NOT_FOUND;
			case "EVT_CODE_SAS_SMP_FUNC_FAILED" : return self::EVT_CODE_SAS_SMP_FUNC_FAILED;
			case "EVT_CODE_SAS_SMP_CRC_ERR" : return self::EVT_CODE_SAS_SMP_CRC_ERR;
			case "EVT_CODE_SAS_MULTI_SUBTRACTIVE" : return self::EVT_CODE_SAS_MULTI_SUBTRACTIVE;
			case "EVT_CODE_SAS_TABEL_TO_TABLE" : return self::EVT_CODE_SAS_TABEL_TO_TABLE;
			case "EVT_CODE_SAS_MULTI_PATHS" : return self::EVT_CODE_SAS_MULTI_PATHS;
			case "EVT_CODE_SAS_WIDE_PORT_LOST_LINK_ON_PHY" : return self::EVT_CODE_SAS_WIDE_PORT_LOST_LINK_ON_PHY;
			case "EVT_CODE_SAS_WIDE_PORT_REST_LINK_ON_PHY" : return self::EVT_CODE_SAS_WIDE_PORT_REST_LINK_ON_PHY;
			case "EVT_CODE_SAS_PHY_EXCEED_ERR_RATE" : return self::EVT_CODE_SAS_PHY_EXCEED_ERR_RATE;
			case "EVT_CODE_SAS_SATA_MIX_NOT_SUPPORTED" : return self::EVT_CODE_SAS_SATA_MIX_NOT_SUPPORTED;
			
			case "EVT_CODE_ENCL_SES_DISCOVERED" : return self::EVT_CODE_ENCL_SES_DISCOVERED;
			case "EVT_CODE_ENCL_SAFTE_DISCOVERED" : return self::EVT_CODE_ENCL_SAFTE_DISCOVERED;
			case "EVT_CODE_ENCL_COMMUNICATION_LOST" : return self::EVT_CODE_ENCL_COMMUNICATION_LOST;
			case "EVT_CODE_ENCL_COMMUNICATION_RESTORED" : return self::EVT_CODE_ENCL_COMMUNICATION_RESTORED;
			case "EVT_CODE_ENCL_FAN_FAILED" : return self::EVT_CODE_ENCL_FAN_FAILED;
			case "EVT_CODE_ENCL_FAN_INSERTED" : return self::EVT_CODE_ENCL_FAN_INSERTED;
			case "EVT_CODE_ENCL_FAN_REMOVED" : return self::EVT_CODE_ENCL_FAN_REMOVED;
			case "EVT_CODE_ENCL_PS_FAILED" : return self::EVT_CODE_ENCL_PS_FAILED;
			case "EVT_CODE_ENCL_PS_INSERTED" : return self::EVT_CODE_ENCL_PS_INSERTED;
			case "EVT_CODE_ENCL_PS_REMOVED" : return self::EVT_CODE_ENCL_PS_REMOVED;
			case "EVT_CODE_ENCL_SIM_FAILED" : return self::EVT_CODE_ENCL_SIM_FAILED;
			case "EVT_CODE_ENCL_SIM_INSERTED" : return self::EVT_CODE_ENCL_SIM_INSERTED;
			case "EVT_CODE_ENCL_SIM_REMOVED" : return self::EVT_CODE_ENCL_SIM_REMOVED;
			case "EVT_CODE_ENCL_TEMP_SENSOR_BELOW_WARNING" : return self::EVT_CODE_ENCL_TEMP_SENSOR_BELOW_WARNING;
			case "EVT_CODE_ENCL_TEMP_SENSOR_BELOW_ERR" : return self::EVT_CODE_ENCL_TEMP_SENSOR_BELOW_ERR;
			case "EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_WARNING" : return self::EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_WARNING;
			case "EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_ERR" : return self::EVT_CODE_ENCL_TEMP_SENSOR_ABOVE_ERR;
			case "EVT_CODE_ENCL_SHUTDOWN" : return self::EVT_CODE_ENCL_SHUTDOWN;
			case "EVT_CODE_ENCL_NOT_SUPPORTED" : return self::EVT_CODE_ENCL_NOT_SUPPORTED;
			case "EVT_CODE_ENCL_FW_MISMATCH" : return self::EVT_CODE_ENCL_FW_MISMATCH;
			case "EVT_CODE_ENCL_SENSOR_BAD" : return self::EVT_CODE_ENCL_SENSOR_BAD;
			case "EVT_CODE_ENCL_PHY_BAD" : return self::EVT_CODE_ENCL_PHY_BAD;
			case "EVT_CODE_ENCL_IS_UNSTABLE" : return self::EVT_CODE_ENCL_IS_UNSTABLE;
			case "EVT_CODE_ENCL_HW_ERR" : return self::EVT_CODE_ENCL_HW_ERR;
			case "EVT_CODE_ENCL_NOT_RESPONDING" : return self::EVT_CODE_ENCL_NOT_RESPONDING;
			case "EVT_CODE_ENCL_HOTPLUG_DETECTED" : return self::EVT_CODE_ENCL_HOTPLUG_DETECTED;
			case "EVT_CODE_ENCL_PS_SWITCHED_OFF" : return self::EVT_CODE_ENCL_PS_SWITCHED_OFF;
			case "EVT_CODE_ENCL_PS_SWITCHED_ON" : return self::EVT_CODE_ENCL_PS_SWITCHED_ON;
			case "EVT_CODE_ENCL_PS_CABLE_REMOVED" : return self::EVT_CODE_ENCL_PS_CABLE_REMOVED;
			case "EVT_CODE_ENCL_PS_CABLE_INSERTED" : return self::EVT_CODE_ENCL_PS_CABLE_INSERTED;
			case "EVT_CODE_ENCL_FAN_RETURN_TO_NORMAL" : return self::EVT_CODE_ENCL_FAN_RETURN_TO_NORMAL;
			case "EVT_CODE_ENCL_TEMP_RETURN_TO_NORMAL" : return self::EVT_CODE_ENCL_TEMP_RETURN_TO_NORMAL;
			case "EVT_CODE_ENCL_FW_DWLD_IN_PRGS" : return self::EVT_CODE_ENCL_FW_DWLD_IN_PRGS;
			case "EVT_CODE_ENCL_FW_DWLD_FAILED" : return self::EVT_CODE_ENCL_FW_DWLD_FAILED;
			case "EVT_CODE_ENCL_TEMP_SENSOR_DIFF_DETECTED" : return self::EVT_CODE_ENCL_TEMP_SENSOR_DIFF_DETECTED;
			case "EVT_CODE_ENCL_FAN_SPEED_CHANGED" : return self::EVT_CODE_ENCL_FAN_SPEED_CHANGED;
			
			case "EVT_CODE_BAT_PRESENT" : return self::EVT_CODE_BAT_PRESENT;
			case "EVT_CODE_BAT_NOT_PRESENT" : return self::EVT_CODE_BAT_NOT_PRESENT;
			case "EVT_CODE_BAT_NEW_BAT_DETECTED" : return self::EVT_CODE_BAT_NEW_BAT_DETECTED;
			case "EVT_CODE_BAT_NEED_REPLACE" : return self::EVT_CODE_BAT_NEED_REPLACE;
			case "EVT_CODE_BAT_REPLACED" : return self::EVT_CODE_BAT_REPLACED;
			case "EVT_CODE_BAT_REMOVED" : return self::EVT_CODE_BAT_REMOVED;
			case "EVT_CODE_BAT_RELEARN_STARTED" : return self::EVT_CODE_BAT_RELEARN_STARTED;
			case "EVT_CODE_BAT_RELEARN_IN_PGRS" : return self::EVT_CODE_BAT_RELEARN_IN_PGRS;
			case "EVT_CODE_BAT_RELEARN_COMPLETED" : return self::EVT_CODE_BAT_RELEARN_COMPLETED;
			case "EVT_CODE_BAT_RELEARN_TIMED_OUT" : return self::EVT_CODE_BAT_RELEARN_TIMED_OUT;
			case "EVT_CODE_BAT_RELEARN_PENDING" : return self::EVT_CODE_BAT_RELEARN_PENDING;
			case "EVT_CODE_BAT_RELEARN_POSTPONED" : return self::EVT_CODE_BAT_RELEARN_POSTPONED;
			case "EVT_CODE_BAT_START_IN_4_DAYS" : return self::EVT_CODE_BAT_START_IN_4_DAYS;
			case "EVT_CODE_BAT_START_IN_2_DAYS" : return self::EVT_CODE_BAT_START_IN_2_DAYS;
			case "EVT_CODE_BAT_START_IN_1_DAY" : return self::EVT_CODE_BAT_START_IN_1_DAY;
			case "EVT_CODE_BAT_START_IN_5_HOURS" : return self::EVT_CODE_BAT_START_IN_5_HOURS;
			case "EVT_CODE_BAT_DISCHARGING" : return self::EVT_CODE_BAT_DISCHARGING;
			case "EVT_CODE_BAT_STARTED_CHARGING" : return self::EVT_CODE_BAT_STARTED_CHARGING;
			case "EVT_CODE_BAT_CHARGE_CMPLT" : return self::EVT_CODE_BAT_CHARGE_CMPLT;
			case "EVT_CODE_BAT_CHARGER_PROBLEM_DETECTED" : return self::EVT_CODE_BAT_CHARGER_PROBLEM_DETECTED;
			case "EVT_CODE_BAT_CAPACITY_BELOW_THRESHOLD" : return self::EVT_CODE_BAT_CAPACITY_BELOW_THRESHOLD;
			case "EVT_CODE_BAT_CAPACITY_ABOVE_THRESHOLD" : return self::EVT_CODE_BAT_CAPACITY_ABOVE_THRESHOLD;
			case "EVT_CODE_BAT_TEMP_IS_LOW" : return self::EVT_CODE_BAT_TEMP_IS_LOW;
			case "EVT_CODE_BAT_TEMP_IS_NORMAL" : return self::EVT_CODE_BAT_TEMP_IS_NORMAL;
			case "EVT_CODE_BAT_TEMP_IS_HIGH" : return self::EVT_CODE_BAT_TEMP_IS_HIGH;
			case "EVT_CODE_BAT_VOLTAGE_LOW" : return self::EVT_CODE_BAT_VOLTAGE_LOW;
			case "EVT_CODE_BAT_VOLTAGE_NORMAL" : return self::EVT_CODE_BAT_VOLTAGE_NORMAL;
			case "EVT_CODE_BAT_VOLTAGE_HIGH" : return self::EVT_CODE_BAT_VOLTAGE_HIGH;
			case "EVT_CODE_BAT_FORCE_WRITE_THROUGH" : return self::EVT_CODE_BAT_FORCE_WRITE_THROUGH;
			case "EVT_CODE_BAT_SAFE_TO_USE_WRITE_BACK" : return self::EVT_CODE_BAT_SAFE_TO_USE_WRITE_BACK;
			
			case "EVT_CODE_FLASH_DWLDED_IMAGE_CORRUPTED" : return self::EVT_CODE_FLASH_DWLDED_IMAGE_CORRUPTED;
			case "EVT_CODE_FLASH_ERASE_ERR" : return self::EVT_CODE_FLASH_ERASE_ERR;
			case "EVT_CODE_FLASH_ERASE_TIMEOUT" : return self::EVT_CODE_FLASH_ERASE_TIMEOUT;
			case "EVT_CODE_FLASH_FLASH_ERR" : return self::EVT_CODE_FLASH_FLASH_ERR;
			case "EVT_CODE_FLASHING_IMAGE" : return self::EVT_CODE_FLASHING_IMAGE;
			case "EVT_CODE_FLASHING_NEW_IMAGE_DONE" : return self::EVT_CODE_FLASHING_NEW_IMAGE_DONE;
			case "EVT_CODE_FLASH_PROGRAMMING_ERR" : return self::EVT_CODE_FLASH_PROGRAMMING_ERR;
			case "EVT_CODE_FLASH_PROGRAMMING_TIMEOUT" : return self::EVT_CODE_FLASH_PROGRAMMING_TIMEOUT;
			case "EVT_CODE_FLASH_UNKNOWN_CHIP_TYPE" : return self::EVT_CODE_FLASH_UNKNOWN_CHIP_TYPE;
			case "EVT_CODE_FLASH_UNKNOWN_CMD_SET" : return self::EVT_CODE_FLASH_UNKNOWN_CMD_SET;
			case "EVT_CODE_FLASH_VERIFY_FAILURE" : return self::EVT_CODE_FLASH_VERIFY_FAILURE;
			case "EVT_CODE_NVRAM_CORRUPT" : return self::EVT_CODE_NVRAM_CORRUPT;
			case "EVT_CODE_NVRAM_MISMACTH_OCCURED" : return self::EVT_CODE_NVRAM_MISMACTH_OCCURED;
			
			case "EVT_CODE_CACHE_NOT_RECV_FROM_TBBU" : return self::EVT_CODE_CACHE_NOT_RECV_FROM_TBBU;
			case "EVT_CODE_CACHE_RECVD_FROM_TBBU" : return self::EVT_CODE_CACHE_RECVD_FROM_TBBU;
			case "EVT_CODE_CACHE_CTRLER_CACHE_DISCARDED" : return self::EVT_CODE_CACHE_CTRLER_CACHE_DISCARDED;
			case "EVT_CODE_CACHE_FAIL_RECV_DUETO_MISMATCH" : return self::EVT_CODE_CACHE_FAIL_RECV_DUETO_MISMATCH;
			case "EVT_CODE_CACHE_DIRTY_DATA_DISCARDED" : return self::EVT_CODE_CACHE_DIRTY_DATA_DISCARDED;
			case "EVT_CODE_CACHE_FLUSH_RATE_CHANGED" : return self::EVT_CODE_CACHE_FLUSH_RATE_CHANGED;
			
			case "EVT_CODE_MISC_FORMAT_COMPLETE" : return self::EVT_CODE_MISC_FORMAT_COMPLETE;
			case "EVT_CODE_MISC_FORMAT_STARTED" : return self::EVT_CODE_MISC_FORMAT_STARTED;
			case "EVT_CODE_MISC_REASSIGN_WRITE_OP" : return self::EVT_CODE_MISC_REASSIGN_WRITE_OP;
			case "EVT_CODE_MISC_UNEXPECTED_SENSE" : return self::EVT_CODE_MISC_UNEXPECTED_SENSE;
			case "EVT_CODE_MISC_REPLACED_MISSING" : return self::EVT_CODE_MISC_REPLACED_MISSING;
			case "EVT_CODE_MISC_NOT_A_CERTIFIED_DRIVE" : return self::EVT_CODE_MISC_NOT_A_CERTIFIED_DRIVE;
			
			case "EVT_CODE_HD_MP_START" : return self::EVT_CODE_HD_MP_START;
			case "EVT_CODE_HD_MP_RESTART" : return self::EVT_CODE_HD_MP_RESTART;
			case "EVT_CODE_HD_MP_PAUSE" : return self::EVT_CODE_HD_MP_PAUSE;
			case "EVT_CODE_HD_MP_RESUME" : return self::EVT_CODE_HD_MP_RESUME;
			case "EVT_CODE_HD_MP_ABORT" : return self::EVT_CODE_HD_MP_ABORT;
			case "EVT_CODE_HD_MP_COMPLETE" : return self::EVT_CODE_HD_MP_COMPLETE;
			case "EVT_CODE_HD_MP_PROGRESS" : return self::EVT_CODE_HD_MP_PROGRESS;
			case "EVT_CODE_HD_MP_ERROR" : return self::EVT_CODE_HD_MP_ERROR;
			case "EVT_CODE_HD_MP_AUTO_PAUSED" : return self::EVT_CODE_HD_MP_AUTO_PAUSED;
			case "EVT_CODE_HD_MP_AUTO_RESUME" : return self::EVT_CODE_HD_MP_AUTO_RESUME;
			
			//sence code related
			case "EVT_CODE_HD_SC_ERROR" : return self::EVT_CODE_HD_SC_ERROR;
			case "EVT_CODE_HD_RCT_ADD" : return self::EVT_CODE_HD_RCT_ADD;
			case "EVT_CODE_HD_RCT_REMOVE" : return self::EVT_CODE_HD_RCT_REMOVE;
			
	/*		case "EVT_CODE_HD_SC_NO_SENSE" : return self::EVT_CODE_HD_SC_NO_SENSE;
			case "EVT_CODE_HD_SC_RECOVERED_ERROR" : return self::EVT_CODE_HD_SC_RECOVERED_ERROR;
			case "EVT_CODE_HD_SC_NOT_READY" : return self::EVT_CODE_HD_SC_NOT_READY;
			case "EVT_CODE_HD_SC_MEDIUM_ERROR" : return self::EVT_CODE_HD_SC_MEDIUM_ERROR;
			case "EVT_CODE_HD_SC_HARDWARE_ERROR" : return self::EVT_CODE_HD_SC_HARDWARE_ERROR;
			case "EVT_CODE_HD_SC_ILLEGAL_REQUEST" : return self::EVT_CODE_HD_SC_ILLEGAL_REQUEST;
			case "EVT_CODE_HD_SC_UNIT_ATTENTION" : return self::EVT_CODE_HD_SC_UNIT_ATTENTION;
			case "EVT_CODE_HD_SC_DATA_PROTECT" : return self::EVT_CODE_HD_SC_DATA_PROTECT;
			case "EVT_CODE_HD_SC_BLANK_CHECK" : return self::EVT_CODE_HD_SC_BLANK_CHECK;
			case "EVT_CODE_HD_SC_VENDOR_SPECIFIC" : return self::EVT_CODE_HD_SC_VENDOR_SPECIFIC;
			case "EVT_CODE_HD_SC_COPY_ABORTED" : return self::EVT_CODE_HD_SC_COPY_ABORTED;
			case "EVT_CODE_HD_SC_ABORTED_COMMAND" : return self::EVT_CODE_HD_SC_ABORTED_COMMAND;
			case "EVT_CODE_HD_SC_VOLUME_OVERFLOW" : return self::EVT_CODE_HD_SC_VOLUME_OVERFLOW;
			case "EVT_CODE_HD_SC_MISCOMPARE" : return self::EVT_CODE_HD_SC_MISCOMPARE;*/
			case "EVT_CODE_HD_SETFREE" : return self::EVT_CODE_HD_SETFREE;
			
			case "EVT_CODE_MDD_ERROR" : return self::EVT_CODE_MDD_ERROR;
			case "EVT_CODE_EXPANDER_PLUG_IN" : return self::EVT_CODE_EXPANDER_PLUG_IN;
			case "EVT_CODE_EXPANDER_PLUG_OUT" : return self::EVT_CODE_EXPANDER_PLUG_OUT;
			
			case "EVT_Unknown" : return self::EVT_Unknown;
			default: return $EventCode;
		}
	}
}

class ComError
{
	const ERR_GENERIC = 2;
	const ERR_GENERIC_STR = "Error: Generic Error";
	const ERR_RAID = 50;
	const ERR_RAID_STR = "Error: RAID Error";
	const ERR_CORE = 100;
	const ERR_CORE_STR = "Error: Core error";
	const ERR_API = 150;
	const ERR_API_STR = "Error: API error";
	const ERR_NONE = 0;
	const ERR_NONE_STR = "Error: no error";
	const ERR_FAIL = 1;
	const ERR_FAIL_STR = "Error: failed";
	const ERR_UNKNOWN = 3;
	const ERR_UNKNOWN_STR = "Error: Unknown Error";
	const ERR_NO_RESOURCE = 4;
	const ERR_NO_RESOURCE_STR = "Error: Resource not available";
	const ERR_REQ_OUT_OF_RANGE = 5;
	const ERR_REQ_OUT_OF_RANGE_STR = "Error: Data out of range";
	const ERR_INVALID_REQUEST = 6;
	const ERR_INVALID_REQUEST_STR = "Error: Invalid request";
	const ERR_INVALID_PARAMETER = 7;
	const ERR_INVALID_PARAMETER_STR = "Error: Invalid request parameter";
	const ERR_INVALID_LD_ID = 8;
	const ERR_INVALID_LD_ID_STR = "Error: Invalid virtual disk id";
	const ERR_INVALID_HD_ID = 9;
	const ERR_INVALID_HD_ID_STR = "Error: Invalid physical disk id";
	const ERR_INVALID_EXP_ID = 10;
	const ERR_INVALID_EXP_ID_STR = "Error: Invalid expander id";
	const ERR_INVALID_PM_ID = 11;
	const ERR_INVALID_PM_ID_STR = "Error: Invalid port multiplexer id";
	const ERR_INVALID_BLOCK_ID = 12;
	const ERR_INVALID_BLOCK_ID_STR = "Error: Invalid block disk id";
	const ERR_INVALID_ADAPTER_ID = 13;
	const ERR_INVALID_ADAPTER_ID_STR = "Error: Invalid adapter id";
	const ERR_INVALID_RAID_MODE = 14;
	const ERR_INVALID_RAID_MODE_STR = "Error: Invalid RAID level";
	const ERR_INVALID_ENC_ID = 15;
	const ERR_INVALID_ENC_ID_STR = "Error: Invalid enclosure id";
	const ERR_INVALID_BU_ID = 16;
	const ERR_INVALID_BU_ID_STR = "Error: Invalid BBU id";
	const ERR_INVALID_DG_ID = 17;
	const ERR_INVALID_DG_ID_STR = "Error: Invalid array id";
	const ERR_INVALID_ENC_ELEMENT_ID = 18;
	const ERR_INVALID_ENC_ELEMENT_ID_STR = "Error: Invalid enclosure element id";
	const ERR_NOT_SUPPORTED = 19;
	const ERR_NOT_SUPPORTED_STR = "Error: Not supported";
	const ERR_DRIVER_SENSOR = 20;
	const ERR_DRIVER_SENSOR_STR = "Error: Link time out";
	const ERR_TARGET_IN_LD_FUNCTIONAL = 51;
	const ERR_TARGET_IN_LD_FUNCTIONAL_STR = "Error: Target physical disk is part of the virtual disk and is functional";
	const ERR_TARGET_NO_ENOUGH_SPACE = 52;
	const ERR_TARGET_NO_ENOUGH_SPACE_STR = "Error: Target disk doesn't have enough space";
	const ERR_HD_IS_NOT_SPARE = 53;
	const ERR_HD_IS_NOT_SPARE_STR = "Error: Specified physical disk is not a spare disk";
	const ERR_HD_IS_SPARE = 54;
	const ERR_HD_IS_SPARE_STR = "Error: Specified physical disk is a spare disk";
	const ERR_HD_NOT_EXIST = 55;
	const ERR_HD_NOT_EXIST_STR = "Error: Specified physical disk doesn't exist";
	const ERR_HD_IS_ASSIGNED_ALREADY = 56;
	const ERR_HD_IS_ASSIGNED_ALREADY_STR = "Error: Specified physical disk is assigned to a virtual disk";
	const ERR_INVALID_HD_COUNT = 57;
	const ERR_INVALID_HD_COUNT_STR = "Error: Invalid physical disk count";
	const ERR_LD_NOT_READY = 58;
	const ERR_LD_NOT_READY_STR = "Error: Virtual disk is not ready to receive command";
	const ERR_LD_NOT_EXIST = 59;
	const ERR_LD_NOT_EXIST_STR = "Error: Specified virtual disk doesn't exist";
	const ERR_LD_IS_FUNCTIONAL = 60;
	const ERR_LD_IS_FUNCTIONAL_STR = "Error: Specified virtual disk is functional";
	const ERR_HAS_BGA_IN_VD = 61;
	const ERR_HAS_BGA_IN_VD_STR = "Error: Virtual disk currently has BGA";
	const ERR_NO_BGA_ACTIVITY = 62;
	const ERR_NO_BGA_ACTIVITY_STR = "Error: No BGA";
	const ERR_BGA_RUNNING = 63;
	const ERR_BGA_RUNNING_STR = "Error: BGA is running";
	const ERR_RAID_NO_AVAILABLE_ID = 64;
	const ERR_RAID_NO_AVAILABLE_ID_STR = "Error: Internal error, no virtual disk id available";
	const ERR_LD_NO_ATAPI = 65;
	const ERR_LD_NO_ATAPI_STR = "Error: Can not create Virtual disk with ATAPI disk";
	const ERR_INVALID_RAID6_PARITY_DISK_COUNT = 66;
	const ERR_INVALID_RAID6_PARITY_DISK_COUNT_STR = "Error: Invalid # of parity disks for RAID6 or RAID60";
	const ERR_INVALID_BLOCK_SIZE = 67;
	const ERR_INVALID_BLOCK_SIZE_STR = "Error: Invalid block size";
	const ERR_MIGRATION_NOT_NEED = 68;
	const ERR_MIGRATION_NOT_NEED_STR = "Error: Migration is not necessary";
	const ERR_STRIPE_BLOCK_SIZE_MISMATCH = 69;
	const ERR_STRIPE_BLOCK_SIZE_MISMATCH_STR = "Error: Stripe block size mismatch";
	const ERR_MIGRATION_NOT_SUPPORT = 70;
	const ERR_MIGRATION_NOT_SUPPORT_STR = "Error: Migration is not supported";
	const ERR_LD_NOT_FULLY_INITED = 71;
	const ERR_LD_NOT_FULLY_INITED_STR = "Error: Virtual disk is not fully initialized";
	const ERR_LD_NAME_INVALID = 72;
	const ERR_LD_NAME_INVALID_STR = "Error: Virtual disk name is invalid";
	const ERR_HD_TYPE_MISMATCH = 73;
	const ERR_HD_TYPE_MISMATCH_STR = "Error: Physical disk type mismatch";
	const ERR_HD_SECTOR_SIZE_MISMATCH = 74;
	const ERR_HD_SECTOR_SIZE_MISMATCH_STR = "Error: Physical disk sector size mismatch";
	const ERR_NO_LD_IN_DG = 75;
	const ERR_NO_LD_IN_DG_STR = "Error: No virtual disk in array";
	const ERR_HAS_LD_IN_DG = 76;
	const ERR_HAS_LD_IN_DG_STR = "Error: Has virtual disk in array";
	const ERR_NO_ROOM_FOR_SPARE = 77;
	const ERR_NO_ROOM_FOR_SPARE_STR = "Error: Disk space is too small to be assigned as spare drive";
	const ERR_SPARE_IS_IN_MULTI_DG = 78;
	const ERR_SPARE_IS_IN_MULTI_DG_STR = "Error: Disk is already assigned as a spare drive for an array";
	const ERR_DG_HAS_MISSING_PD = 79;
	const ERR_DG_HAS_MISSING_PD_STR = "Error: Disk is missing from an array";	
	const ERR_LD_NOT_IMPORTABLE = 80;
	const ERR_LD_NOT_IMPORTABLE_STR = "Error: Virtual disk is not importable";	
	const ERR_HAS_MIGRATION_ON_DG = 81;
	const ERR_HAS_MIGRATION_ON_DG_STR = "Error: Another array is currently doing migration. Only one migration is allowed at any time";		
	const ERR_HAS_BGA_IN_DG = 82;
	const ERR_HAS_BGA_IN_DG_STR = "Error: Array currently has BGA";
	const ERR_HD_CANNOT_SET_DOWN = 83;
	const ERR_HD_CANNOT_SET_DOWN_STR = "Error: Physical disk cannot be set down";
	
	const ERR_INVALID_MATCH_ID = 151;
	const ERR_INVALID_MATCH_ID_STR = "Error: Adapter id and device id doesn't match";
	const ERR_INVALID_HDCOUNT = 152;
	const ERR_INVALID_HDCOUNT_STR = "Error: Invalid physical disk count";
	const ERR_INVALID_BGA_ACTION = 153;
	const ERR_INVALID_BGA_ACTION_STR = "Error: Invalid BGA action";
	const ERR_HD_IN_DIFF_CARD = 154;
	const ERR_HD_IN_DIFF_CARD_STR = "Error: Specified physical disk(s) are on different adapter";
	const ERR_INVALID_FLASH_TYPE = 155;
	const ERR_INVALID_FLASH_TYPE_STR = "Error: Invalid flash type";
	const ERR_INVALID_FLASH_ACTION = 156;
	const ERR_INVALID_FLASH_ACTION_STR = "Error: Invalid flash action";
	const ERR_TOO_FEW_EVENT = 157;
	const ERR_TOO_FEW_EVENT_STR = "Error: Too few events";
	const ERR_VD_HAS_RUNNING_OS = 158;
	const ERR_VD_HAS_RUNNING_OS_STR = "Error: Virtual disk has running OS on it";
	const ERR_DISK_HAS_RUNNING_OS = 159;
	const ERR_DISK_HAS_RUNNING_OS_STR = "Error: Disk has running OS on it";
	const ERR_COMMAND_NOT_SUPPURT = 160;
	const ERR_COMMAND_NOT_SUPPURT_STR = "Error: This command is not support on this produce";
	const ERR_MIGRATION_LIMIT = 161;
	const ERR_MIGRATION_LIMIT_STR = "Error: Can not migrate more than one virtual disk in each adapter";
	const ERR_SGPIO_CONTROL_NOT_SUPPORTED = 162;
	const ERR_SGPIO_CONTROL_NOT_SUPPORTED_STR = "Error: SGPIO control not support";
	const ERR_COUNT_OUT_OF_RANGE = 163;
	const ERR_COUNT_OUT_OF_RANGE_STR = "Error: Count out of range";
	const ERR_IOCTL_NO_RESOURCE = 164;
	const ERR_IOCTL_NO_RESOURCE_STR = "Error: IoControl buffer size is too big";
	
	public static function getErrStr($ErrorCode)
	{
		switch ($ErrorCode)
		{
			case self::ERR_GENERIC : return self::ERR_GENERIC_STR;
			case self::ERR_RAID : return self::ERR_RAID_STR;
			case self::ERR_CORE : return self::ERR_CORE_STR;
			case self::ERR_API : return self::ERR_API_STR;
			case self::ERR_NONE : return self::ERR_NONE_STR;
			case self::ERR_FAIL : return self::ERR_FAIL_STR;
			case self::ERR_UNKNOWN : return self::ERR_UNKNOWN_STR;
			case self::ERR_NO_RESOURCE : return self::ERR_NO_RESOURCE_STR;
			case self::ERR_REQ_OUT_OF_RANGE : return self::ERR_REQ_OUT_OF_RANGE_STR;
			case self::ERR_INVALID_REQUEST : return self::ERR_INVALID_REQUEST_STR;
			case self::ERR_INVALID_PARAMETER : return self::ERR_INVALID_PARAMETER_STR;
			case self::ERR_INVALID_LD_ID : return self::ERR_INVALID_LD_ID_STR;
			case self::ERR_INVALID_HD_ID : return self::ERR_INVALID_HD_ID_STR;
			case self::ERR_INVALID_EXP_ID : return self::ERR_INVALID_EXP_ID_STR;
			case self::ERR_INVALID_PM_ID : return self::ERR_INVALID_PM_ID_STR;
			case self::ERR_INVALID_BLOCK_ID : return self::ERR_INVALID_BLOCK_ID_STR;
			case self::ERR_INVALID_ADAPTER_ID : return self::ERR_INVALID_ADAPTER_ID_STR;
			case self::ERR_INVALID_RAID_MODE : return self::ERR_INVALID_RAID_MODE_STR;
			case self::ERR_INVALID_ENC_ID : return self::ERR_INVALID_ENC_ID_STR;
			case self::ERR_INVALID_BU_ID : return self::ERR_INVALID_BU_ID_STR;
			case self::ERR_INVALID_DG_ID : return self::ERR_INVALID_DG_ID_STR;
			case self::ERR_INVALID_ENC_ELEMENT_ID : return self::ERR_INVALID_ENC_ELEMENT_ID_STR;
			case self::ERR_NOT_SUPPORTED : return self::ERR_NOT_SUPPORTED_STR;
			case self::ERR_DRIVER_SENSOR : return self::ERR_DRIVER_SENSOR_STR;
			case self::ERR_TARGET_IN_LD_FUNCTIONAL : return self::ERR_TARGET_IN_LD_FUNCTIONAL_STR;
			case self::ERR_TARGET_NO_ENOUGH_SPACE : return self::ERR_TARGET_NO_ENOUGH_SPACE_STR;
			case self::ERR_HD_IS_NOT_SPARE : return self::ERR_HD_IS_NOT_SPARE_STR;
			case self::ERR_HD_IS_SPARE : return self::ERR_HD_IS_SPARE_STR;
			case self::ERR_HD_NOT_EXIST : return self::ERR_HD_NOT_EXIST_STR;
			case self::ERR_HD_IS_ASSIGNED_ALREADY : return self::ERR_HD_IS_ASSIGNED_ALREADY_STR;
			case self::ERR_INVALID_HD_COUNT : return self::ERR_INVALID_HD_COUNT_STR;
			case self::ERR_LD_NOT_READY : return self::ERR_LD_NOT_READY_STR;
			case self::ERR_LD_NOT_EXIST : return self::ERR_LD_NOT_EXIST_STR;
			case self::ERR_LD_IS_FUNCTIONAL : return self::ERR_LD_IS_FUNCTIONAL_STR;
			case self::ERR_HAS_BGA_IN_VD : return self::ERR_HAS_BGA_IN_VD_STR;
			case self::ERR_NO_BGA_ACTIVITY : return self::ERR_NO_BGA_ACTIVITY_STR;
			case self::ERR_BGA_RUNNING : return self::ERR_BGA_RUNNING_STR;
			case self::ERR_RAID_NO_AVAILABLE_ID : return self::ERR_RAID_NO_AVAILABLE_ID_STR;
			case self::ERR_LD_NO_ATAPI : return self::ERR_LD_NO_ATAPI_STR;
			case self::ERR_INVALID_RAID6_PARITY_DISK_COUNT : return self::ERR_INVALID_RAID6_PARITY_DISK_COUNT_STR;
			case self::ERR_INVALID_BLOCK_SIZE : return self::ERR_INVALID_BLOCK_SIZE_STR;
			case self::ERR_MIGRATION_NOT_NEED : return self::ERR_MIGRATION_NOT_NEED_STR;
			case self::ERR_STRIPE_BLOCK_SIZE_MISMATCH : return self::ERR_STRIPE_BLOCK_SIZE_MISMATCH_STR;
			case self::ERR_MIGRATION_NOT_SUPPORT : return self::ERR_MIGRATION_NOT_SUPPORT_STR;
			case self::ERR_LD_NOT_FULLY_INITED : return self::ERR_LD_NOT_FULLY_INITED_STR;
			case self::ERR_LD_NAME_INVALID : return self::ERR_LD_NAME_INVALID_STR;
			case self::ERR_HD_TYPE_MISMATCH : return self::ERR_HD_TYPE_MISMATCH_STR;
			case self::ERR_HD_SECTOR_SIZE_MISMATCH : return self::ERR_HD_SECTOR_SIZE_MISMATCH_STR;
			case self::ERR_NO_LD_IN_DG : return self::ERR_NO_LD_IN_DG_STR;
			case self::ERR_HAS_LD_IN_DG : return self::ERR_HAS_LD_IN_DG_STR;
			case self::ERR_NO_ROOM_FOR_SPARE : return self::ERR_NO_ROOM_FOR_SPARE_STR;
			case self::ERR_SPARE_IS_IN_MULTI_DG : return self::ERR_SPARE_IS_IN_MULTI_DG_STR;
			case self::ERR_DG_HAS_MISSING_PD : return self::ERR_DG_HAS_MISSING_PD_STR;
			case self::ERR_LD_NOT_IMPORTABLE : return self::ERR_LD_NOT_IMPORTABLE_STR;
			case self::ERR_HAS_MIGRATION_ON_DG : return self::ERR_HAS_MIGRATION_ON_DG_STR;
			case self::ERR_HAS_BGA_IN_DG : return self::ERR_HAS_BGA_IN_DG_STR;
			case self::ERR_HD_CANNOT_SET_DOWN : return self::ERR_HD_CANNOT_SET_DOWN_STR;
			case self::ERR_INVALID_MATCH_ID : return self::ERR_INVALID_MATCH_ID_STR;
			case self::ERR_INVALID_HDCOUNT : return self::ERR_INVALID_HDCOUNT_STR;
			case self::ERR_INVALID_BGA_ACTION : return self::ERR_INVALID_BGA_ACTION_STR;
			case self::ERR_HD_IN_DIFF_CARD : return self::ERR_HD_IN_DIFF_CARD_STR;
			case self::ERR_INVALID_FLASH_TYPE : return self::ERR_INVALID_FLASH_TYPE_STR;
			case self::ERR_INVALID_FLASH_ACTION : return self::ERR_INVALID_FLASH_ACTION_STR;
			case self::ERR_TOO_FEW_EVENT : return self::ERR_TOO_FEW_EVENT_STR;
			case self::ERR_VD_HAS_RUNNING_OS : return self::ERR_VD_HAS_RUNNING_OS_STR;
			case self::ERR_DISK_HAS_RUNNING_OS : return self::ERR_DISK_HAS_RUNNING_OS_STR;
			case self::ERR_COMMAND_NOT_SUPPURT : return self::ERR_COMMAND_NOT_SUPPURT_STR;
			case self::ERR_MIGRATION_LIMIT : return self::ERR_MIGRATION_LIMIT_STR;
			//case self::ERR_INVALID_ENCACTIONTYPE : return self::ERR_INVALID_ENCACTIONTYPE_STR;
			//case self::ERR_INVALID_ENCACTION : return self::ERR_INVALID_ENCACTION_STR;
			case self::ERR_SGPIO_CONTROL_NOT_SUPPORTED : return self::ERR_SGPIO_CONTROL_NOT_SUPPORTED_STR;
			case self::ERR_COUNT_OUT_OF_RANGE : return self::ERR_COUNT_OUT_OF_RANGE_STR;
			case self::ERR_IOCTL_NO_RESOURCE : return self::ERR_IOCTL_NO_RESOURCE_STR;
			default:
				return self::ERR_UNKNOWN_STR ;
		}
	}
}

//app types

class ScheduleSettingType
{
	const No_REPEAT = 0;
	const DAY_REPEAT = 1;
	const WEEK_REPEAT = 2;
	const MONTH_REPEAT = 3;
}

class ScheduleStatus
{
	const NOT_RUN = 0;
	const READING = 1;
	const RUN = 2;
}

class FlashResult
{
	const FLASH_SUCCESS = 1;
	const FLASH_UPLOADFAILED = 2;
	const FLASH_INVALIDFILE = 3;
	const FLASH_FILETOOLARGE = 4;
	const FLASH_GETVERSIONFAILED = 5;
}

class FlashAction
{
	const FLASH_DOWNLOAD = 0xf0;
	const FLASH_UPLOAD = 0xf;
}

class FlashType
{
	const FLASH_TYPE_CONFIG = 0;
	const FLASH_TYPE_BIN = 1;
	const FLASH_TYPE_BIOS = 2;
	const FLASH_TYPE_FIRMWARE = 3;
}

class ScheduleResultType
{
	const SUCCESS = 0;
	const FAILED = 1;
}

//scheduled bga type
class ScheduledBGAType
{
	//VD
	const LD_BGA_CONSISTENCY_CHECK = LdBgaStatus::LD_BGA_CONSISTENCY_CHECK;
	const LD_BGA_CONSISTENCY_FIX = LdBgaStatus::LD_BGA_CONSISTENCY_FIX;
	const LD_BGA_INIT_BACK = LdBgaStatus::LD_BGA_INIT_BACK;
	const LD_BGA_MIGRATION = LdBgaStatus::LD_BGA_MIGRATION;
	const LD_BGA_REBUILD = LdBgaStatus::LD_BGA_REBUILD;
	//PD
	const HD_BGA_MP = 33;
	
	//Disk Group
	//const DG_BGA_CONSISTENCY_CHECK = 34;
	//const DG_BGA_CONSISTENCY_FIX = 35;
	//const DG_BGA_INIT_BACK = 36;
	const DG_BGA_MIGRATION = 37;
	const DG_BGA_REBUILD = 38;
	
	//BBU related
	const BBU_BGA_RELEARN = 50;
	const BBU_BGA_RELEARN_STR = "Relearn";
	
	const BGA_UNKNOWN_STR = "Unknown";
	
	public static function getBGATypeString($type)
	{
		switch ($type)
		{
			case self::LD_BGA_CONSISTENCY_CHECK :
				return LdBgaStatus::LD_BGA_CONSISTENCY_CHECK_STR;
			case self::LD_BGA_CONSISTENCY_FIX :
				return LdBgaStatus::LD_BGA_CONSISTENCY_FIX_STR;
			case self::LD_BGA_INIT_BACK :
				return LdBgaStatus::LD_BGA_INIT_BACK_STR;
			case self::LD_BGA_MIGRATION :
				return LdBgaStatus::LD_BGA_MIGRATION_STR;
			case self::LD_BGA_REBUILD :
				return LdBgaStatus::LD_BGA_REBUILD_STR;
			case self::HD_BGA_MP :
				return HdBgaStatus::HD_BGA_MP_STR;
			case self::DG_BGA_MIGRATION :
				return LdBgaStatus::LD_BGA_MIGRATION_STR;
			case self::DG_BGA_REBUILD :
				return LdBgaStatus::LD_BGA_REBUILD_STR;
			case self::BBU_BGA_RELEARN :
				return self::BBU_BGA_RELEARN_STR;
			default:
				return self::BGA_UNKNOWN_STR;
		}
	}
}

class WeekDay
{
	const SUNDAY = 0;
	const SUNDAY_STR = 'Sunday';
	const MONDAY = 1;
	const MONDAY_STR = 'Monday';
	const TUESDAY = 2;
	const TUESDAY_STR = 'Tuesday';
	const WEDNESDAY = 3;
	const WEDNESDAY_STR = 'Wednesday';
	const THURSDAY = 4;
	const THURSDAY_STR = 'Thursday';
	const FRIDAY = 5;
	const FRIDAY_STR = 'Friday';
	const SATURDAY = 6;
	const SATURDAY_STR = 'Saturday';
	public static function getWeekDayStr($weekDay)
	{
		switch ($weekDay)
		{
			case self::SUNDAY :
				return self::SUNDAY_STR;
			case self::MONDAY  :
				return self::MONDAY_STR ;
			case self::TUESDAY  :
				return self::TUESDAY_STR ;
			case self::WEDNESDAY  :
				return self::WEDNESDAY_STR ;
			case self::THURSDAY  :
				return self::THURSDAY_STR ;
			case self::FRIDAY  :
				return self::FRIDAY_STR ;
			case self::SATURDAY  :
				return self::SATURDAY_STR ;
		}
	}
}

//user type

class UserType
{
	const ADMIN = 1;
	const ADMIN_STR = 'Administrator';
	const GUEST = 2;//0
	const GUEST_STR = 'Guest';
	const REGECT = 0;//2
	
	public static function getUserTypeStr($Type)
	{
		switch ($Type)
		{
			case self::ADMIN :
				return self::ADMIN_STR ;
			case self::GUEST :
				return self::GUEST_STR ;
		}
	}
}

class APIMaxSupport
{
	const MAX_HD_SUPPORTED_API = 128;
	const MAX_EXPANDER_SUPPORTED_API = 16;
	const MAX_PM_SUPPORTED_API = 8;
	const MAX_LD_SUPPORTED_API = 32;
	const MAX_DG_SUPPORTED_API = 64;
	const MAX_BLOCK_SUPPORTED_API = 512;
	const MAX_BLOCK_PER_HD_SUPPORTED_API = 16;
	const MAX_ENCLOSURE_API = 32;
	const MAX_SPARE_PD_SUPPORTED_API = 8;
}

class AlertMsg
{
	const LDINFO_DELETE_LD = "WARNING! ALL DATA WILL BE ERASED! Are you sure you want to delete this Virtual Disk?";
	const LDINFO_DELETE_MBR = "Do you want to delete the partition information if it has one?";
	const MIGRATE_LIMIT_ERR = "Migration source and target VD should have at least one common PD!";
	const MIGRATE_DG_LIMIT_ERR = "Migration source and target VD should have at least one common PD!";
	const PERMISSION_CHECK_FAIL = "You don't have permission to do this operation. Please login as administrator first.";
	const MIGRATE_CANCEL = "Are you sure you want to cancel the VD Migration?";
	const CREATE_CANCEL = "Are you sure you want to cancel the VD Creation?";
	const INIT_CANCEL = "Are you sure you want to cancel the VD Initialization?";
	const REBUILD_CANCEL = "Are you sure you want to cancel the VD Rebuilding?";
	const CHECK_CANCEL = "Are you sure you want to cancel the VD Consistency Check?";
	const SCHEDULE_CANCEL = "Are you sure you want to cancel BGA Schedule Time Setting?";
	const MP_CANCEL = "Are you sure you want to cancel Media Patrol?";
	
	const MP_FREE_PD_ERROR = "Media patrol on free disk is not allowed.";
	const CREATE_VD_FREE_PD_ERROR = "Non-free disk can not be used to create VD.";

	const DGINFO_DELETE_DG = "Are you sure you want to delete this Array?";
}

/***********************************
 * to get request parameter submited 
 * by browser
 ***********************************/
function getRequestPara($Str)
{
	$RetVal = null;
	foreach ($_GET as $key=>$value)
	{
		if ($key == $Str) {
			$RetVal = $value;
		}
	}
	
	foreach ($_POST as $key=>$value)
	{
		if ($key == $Str) {
			$RetVal = $value;
		}
	}
	
	return $RetVal;
}

function getSessionPara($Str)
{
	$RetVal = null;
	foreach ($_SESSION as $key=>$value)
	{
		if ($key == $Str) {
			$RetVal = $value;
		}
	}
	
	return $RetVal;
}

function getCookiePara($Str)
{
	$RetVal = null;
	foreach ($_COOKIE as $key=>$value)
	{
		if ($key == $Str) {
			$RetVal = $value;
		}
	}
	
	return $RetVal;
}

/***********************************
 * to get the url base
 * 
 ***********************************/

function getBaseURL()
{
	$url = "http://" . $_SERVER['SERVER_NAME'] . ":8845";
	
	$request_url = $_SERVER['REQUEST_URI'];
	
	// do some 
	$strs = explode("/",$request_url);
	
	if (sizeof($strs) > 2) {
		$url .= "/" . $strs[1];	
	}
	
	return $url . "/";
}

function getSecureBaseURL()
{
	$url = "https://" . $_SERVER['SERVER_NAME'] . ":8443";
	
	$request_url = $_SERVER['REQUEST_URI'];
	
	// do some 
	$strs = explode("/",$request_url);
	
	if (sizeof($strs) > 2) {
		$url .= "/" . $strs[1];	
	}
	
	return $url . "/";
}

/*
function xml_entity_encode($str)
{
	$str = str_replace("&", "&amp;", $str);
	$str = str_replace(">", "&gt;", $str);
	$str = str_replace("<", "&lt;", $str);
	$str = str_replace('"', "&quot;", $str);
	$str = str_replace("'", "&apos;", $str);
	
	return $str;
}
*/

function getUrlPropertyValue($str,$name,$sep = '|')
{
	$arr = explode($sep,$str);
	
	foreach ($arr as $entity)
	{
		$entity = trim($entity);
		$index = strpos($entity,$name);
		
		if ($index !== false) {
			return trim(substr($entity,$index + strlen($name) + 1));
		}
	}
	
	return "";
}

/*******************************
 * mru version string 
 * for mru utility to display the 
 * version info
 ******************************/
function get_mru_version_string()
{
	return "4.1.0.1700";
}

/******************************
 * format ld size and hd size
 ******************************/

function FormatSize($size,$UseThorSizePolicy=0)
{
    $size = ConvertSize($size,$UseThorSizePolicy);
	return number_format($size,1) . " GB";
}

function ConvertSize($size,$UseThorSizePolicy=0)
{
	if ($UseThorSizePolicy)
    	$size = floor($size / UNIT_K / UNIT_K * 10) / 10;
    else
    	$size = round($size / UNIT_KILO / UNIT_K * 10) / 10;
	return $size;
}

class PHPPageName
{
	const TargetPageName = "JumpPage.php";
	const CmdPageName = "command.php";
}

class APICmd
{
	const flashBios = "flashBios";
	const ldondgbgaControl = "ldondgbgaControl";
	const saveDgConfig = "saveDgConfig";
	const createVdOnDg = "createVdOnDg";
	const createDGSubmit = "createDGSubmit";
	const createDGNext = "createDGNext";
	const deleteDG = "deleteDG";
	const migrateDG = "migrateDG";
	const rebuildDG = "rebuildDG";
	const initVdOnDg = "initVdOnDg";
	const checkVdOnDg = "checkVdOnDg";
	const deleteVdOnDg = "deleteVdOnDg";
	const saveVdOnDg = "saveVdOnDg";
	const dgbgaControl = "dgbgaControl";
	const initLD = "initLD";
	const checkLD = "checkLD";
	const quickCreateVD = "quickCreateVD";
	const createLD = "createLD";
	const deleteLD = "deleteLD";
	const bgaControl = "bgaControl";
	const migrateLD = "migrateLD";
	const rebuildLD = "rebuildLD";
	const saveLDConfig = "saveLDConfig";
	const importLD = "importLD";
	const saveHDConfig = "saveHDConfig";
	const setHDStatus = "setHDStatus";
	const saveLEDConfig = "saveLEDConfig";
	const saveENCElementConfig = "saveENCElementConfig";
	const saveHBAConfig = "saveHBAConfig";
	const clearSP = "clearSP";
	const setGlobalSP = "setGlobalSP";
	const setLDSP = "setLDSP";
	const getMigratedLDSize = "getMigratedLDSize";
	const getEventGrid = "getEventGrid";
	const clearEvents = "clearEvents";
	const saveBBUConfig = "saveBBUConfig";
	const saveBBUSchedule = "saveBBUSchedule";
	const muteAdapter = "muteAdapter";
	//pd related
	const dataScrubPd = "dataScrubPd";
	const pdbgaControl = "pdbgaControl";
	const mediaPatrolPD = "mediaPatrolPD";
	const setDedicatedSP = "setDedicatedSP";
	const wipePD = "wipePD";
	
	const getMigratedDgSize = "getMigratedDgSize";
	
	//app CMD
	const testMailSetting = 'testMailSetting';
}

class Target
{	
	const AboutPage = "AboutPage";
	const LoginPage = "LoginPage";
	const LdListPage = "LdListPage";
	const MarvellRaidPage = "MarvellRaidPage";
	
	const getArrayOperation = "getArrayOperation";
	const getVdOnDgOperation = "getVdOnDgOperation";
	const getVdOperation = "getVdOperation";
	const getPdOperation = "getPdOperation";
	
	const getSystemSubPage = "getSystemSubPage";
	const getArraySubPage = "getArraySubPage";
	const getIndependentVDPage = "getIndependentVDPage";
	const getVDSubPage = "getVDSubPage";
	const getBBUSubPage = "getBBUSubPage";
	const getEventList = "getEventList";
	const getHdDetail = "getHdDetail";
	const getEnclDetail = "getEnclDetail";
	const getExpandersWithoutEncl = "getExpandersWithoutEncl";
	const getPMsWithoutEncl = "getPMsWithoutEncl";
	const getHBADetail = "getHBADetail";
	const getTreeNodes = "getTreeNodes";
	const getVdBGAProgress = "getVdBGAProgress";
	const getVdOnDgBGAProgress = "getVdOnDgBGAProgress";
	const getBBUInfo = "getBBUInfo";
	const getHDBGAProgress = "getHDBGAProgress";
	const getLdMax = "getLdMax";
	const EventsSaveFilePage = "EventsSaveFilePage";
	const SetDedicatedSparePage = "SetDedicatedSparePage";
	const InitPage = "InitPage";
	const MigrateDgPage = "MigrateDgPage";
	const QuickCreatePage = "QuickCreatePage";
	const CreateDgPage = "CreateDgPage";
	const CreateVdOnDgPage = "CreateVdOnDgPage";
	const CreatePage1 = "CreatePage1";
	const CreatePage2 = "CreatePage2";
	const MigratePage = "MigratePage";
	const MigrateVdPage = "MigrateVdPage";
	const CheckPage = "CheckPage";
	const RebuildDgPage = "RebuildDgPage";
	const RebuildPage = "RebuildPage";
	const AccountPage1 = "AccountPage1";
	const ToolsetPage = "ToolsetPage";
	const BiosFlashPage = "BiosFlashPage";
	const BiosFlashFramePage = "BiosFlashFramePage";
	const BgaSchedulePage = "BgaSchedulePage";
	const NewTimesettingPage = "NewTimesettingPage";
	const BBUSchedulePage = "BBUSchedulePage";
	const EmailSettingPage = "EmailSettingPage";
	const getArrayDynamicSubPage = "getArrayDynamicSubPage";
}

?>
