<?php
class ActionMigrateLD extends UserAction 
{
	private $LD_ID;
		
	private $RaidMode = 0;
	//private $HDCount = 0;
	private $HDs = 0;
	private $NumParityDisk = 0;
	
	private $original_HDs = "";
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->LD_ID = getRequestPara("LDID");
		$this->HDs = getRequestPara("HDs");
		$this->RaidMode = getRequestPara("RaidMode");
		if ($this->RaidMode == RAIDMode::LD_MODE_RAID6 
			|| $this->RaidMode == RAIDMode::LD_MODE_RAID60) {
			$this->NumParityDisk = getRequestPara("NumOfParityDisk");
		}
	}
	
	private function setOriginalHDs()
	{
		include_once("../phpsrc/baseclass/Device.class.php");
		include_once("../phpsrc/baseclass/SASDevice.class.php");
		include_once("../phpsrc/baseclass/DeviceFactory.class.php");
		include_once("../phpsrc/baseclass/PortDevice.class.php");
		include_once("../phpsrc/baseclass/Block.class.php");
		include_once("../phpsrc/baseclass/HD.class.php");
		include_once("../phpsrc/baseclass/PM.class.php");
		include_once("../phpsrc/baseclass/HBA.class.php");
		include_once("../phpsrc/baseclass/ExpanderDevice.class.php");
		include_once("../phpsrc/baseclass/LD.class.php");

		include_once("../phpsrc/baseclass/LdDetail.class.php");
		
		$ldDtl = new LdDetail();
		$ldDtl->setAdapterID($this->getAdapterID());
		$ldDtl->setID($this->LD_ID);
		$ldDtl->toGetBlockInfo();
		$ldDtl->toGetHDInfo();
		
		$base = $ldDtl->getBaseClasses();
		
		if (sizeof($base)) {
				$ldDetail = array_shift($base);
				foreach ($ldDetail->getBlockList() as $blk)
				{
					$hd = $blk->belongHD();
					if ($this->original_HDs !== "") {
						$this->original_HDs .= " " . $hd->getDeviceID();
					}
					else 
					{
						$this->original_HDs .= $hd->getDeviceID();
					}
				}
		}
	}
	
	/*
	check whether one of pd(s) is member disk of original vd
	*/
	private function doCheckMemberDisk()
	{
		#set id of pd disks in target vd
		#set to array
		$Target_HDIDs = array();
		$Target_HDs = explode(" ",$this->HDs);
		foreach ($Target_HDs as $HDID)
		{
			if (trim($HDID) != "") {
				$Target_HDIDs[] = $HDID;
			}
		}
		
		#set id of pd disks in original vd
		#set to array
		$Original_HDIDs = explode(" ",trim($this->original_HDs));
		
		foreach ($Original_HDIDs as $Original_HDID)
		{
			foreach ($Target_HDIDs as $Target_HDID)
			{
				if (intval($Target_HDID) == $Original_HDID) {
					return true;
				}
			}
		}
		
		return false;
	}
	
	private function setCheckMigrateFailXMLRet()
	{
		$this->xmlRet = new FailXMLRet();
		$this->xmlRet->Url = getBaseURL() . "JumpPage.php?Target=" . Target::getIndependentVDPage . "&ID=" . $this->LD_ID ;
		$Err = AlertMsg::MIGRATE_LIMIT_ERR;
		$this->xmlRet->Msg = $Err;
	}
	
	public function doCheckSpare()
	{
		include_once("../phpsrc/baseclass/Device.class.php");
		include_once("../phpsrc/baseclass/SASDevice.class.php");
		include_once("../phpsrc/baseclass/DeviceFactory.class.php");
		include_once("../phpsrc/baseclass/PortDevice.class.php");
		include_once("../phpsrc/baseclass/Block.class.php");
		include_once("../phpsrc/baseclass/HD.class.php");
		include_once("../phpsrc/baseclass/PM.class.php");
		include_once("../phpsrc/baseclass/ExpanderDevice.class.php");

		include_once("../phpsrc/baseclass/HdList.class.php");
		
		$HdList = new HdList();
		$HdList->setAdapterID($this->getAdapterID());
		$HdList->toGetHDRaidStatus();
		
		$HDs = $HdList->getBaseClasses();
		
		#set id of pd disks in target vd
		#set to array
		$Target_HDIDs = array();
		$Target_HDs = explode(" ",$this->HDs);
		foreach ($Target_HDs as $HDID)
		{
			if (trim($HDID) != "") {
				$HDIDs[] = $HDID;
			}
		}
		
		#set id of pd disks in original vd
		#set to array
		$Original_HDIDs = array();
		$Original_HDs = explode(" ",$this->original_HDs);
		foreach ($Original_HDs as $HDID)
		{
			if (trim($HDID) != "") {
				$Original_HDIDs[] = $HDID;
			}
		}
		
		#remove member disk from array
		$noneMemberDisks = array();
		foreach ($Target_HDs as $Target_HDID)
		{
			$isMember = false;
			foreach ($Original_HDIDs as $Original_HDID)
			{
				if (intval($Target_HDID) == $Original_HDID) {
					$isMember = true;
					break;
				}
			}
			if (!$isMember) {
				$noneMemberDisks[] = $Target_HDID;
			}
		}
				
		foreach ($HDs as $HD)
		{
			if ($HD->isSpare()) {
				$HDID = trim($HD->getDeviceID());
				foreach ($noneMemberDisks as $id)
				{
					if ($HDID == $id) {
						return false;
					}
				}
			}
		}
		
		return true;
	}
	
	private function setHDSpareCheckFailXMLRet()
	{
		$this->xmlRet = new FailXMLRet();
		$this->xmlRet->Url = getBaseURL() . "JumpPage.php?Target=" . Target::getIndependentVDPage . "&ID=" . $this->LD_ID ;
		$Err = ComError::ERR_HD_IS_SPARE_STR;
		$this->xmlRet->Msg = $Err;
	}
	
	private function doMigrate()
	{
		$this->ApiCmd = new XMLAPICommand();
		$this->ApiCmd->setCommand(XMLAPICommand::MV_LD_StartMigration);
		$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
		$this->ApiCmd->setCommandPara("LDID",$this->LD_ID);
		$this->ApiCmd->setCommandPara("RaidMode",$this->RaidMode);
		$this->ApiCmd->setCommandPara("NumParityDisk",$this->NumParityDisk);
		//HDCount
		$HDCount = 0;
		$hds = explode(" ",$this->HDs);
		foreach ($hds as $Hd)
		{
			if (trim($Hd) != "") {
				$HDCount ++;
			}
		}
		$this->ApiCmd->setCommandPara("HDCount",$HDCount);
		$this->ApiCmd->setCommandPara("HDIDs",$this->HDs);
		$this->ApiCmd->issueCommand();
		
		if (trim($this->ApiCmd->getResult()->RetVal)) {
			$this->setLDCmdXmlRetFail();
		}
		else {
			$this->setLDCmdXmlRetSuccess();
		}
	}
	
	protected function doAction()
	{
		$this->setOriginalHDs();
		if (!$this->doCheckMemberDisk()) {
			$this->setCheckMigrateFailXMLRet();
			return ;
		}
		
		#check whether non-member disks are spared
		#if spare can not do migration
		if (!$this->doCheckSpare()) {
			$this->setHDSpareCheckFailXMLRet();
			return;
		}
		
		$this->doMigrate();
	}
}
?>