<?php
//include_once("PageDisplayer.class.php");

class PgNewTimesettingDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$smarty = $this->smarty;
		
		$type = getRequestPara('type');
		$jobID = getRequestPara('jobID');
		$cmdPara = getRequestPara('cmdPara');
		$pageID = getRequestPara('pageID');
		$VDID = getRequestPara('VDID');
		$bgaType = getRequestPara('bgaType');
		$startTime= getRequestPara('startTime');
		$repeatType= getRequestPara('repeatType');
		$repeatParam1= getRequestPara('repeatParam1');
		$repeatParam2= getRequestPara('repeatParam2');
		$bgaPage = getRequestPara('bgaPage');
    	$CancelAlert = gettext(AlertMsg::SCHEDULE_CANCEL)." ?";
    	
    	if ($type == 'saveModify' && $cmdPara == null) {
			$da = new BGAJobDataAccess();
			$job = $da->getBGAJobByID($jobID);
			
			if ($job) {
				//get job info
				$cmdPara = $job->getCmdPara();
				$bgaType = $job->getBgaType();
				
				$VDID = $job->getVDID();
				$startTime = $job->getSettingTime();
				$repeatParam1 = $job->getSettingDate();
				$repeatParam2 = $job->getSettingDateSupplement();
				$repeatType = $job->getSettingType();
				
				//format display
				$startTime = substr($startTime,0,2) . ':' . substr($startTime,2,2);
				if ($repeatType == ScheduleSettingType::No_REPEAT) {
					$time  = strtotime($repeatParam1);
					$repeatParam1 = date('m/d/Y',$time);
				}
			}
			else
			{
				$this->displayDefaultPage(Target::BgaSchedulePage);
			}
		}
    	
    	if ($bgaType == LdBgaStatus::LD_BGA_CONSISTENCY_CHECK 
    			|| $bgaType == LdBgaStatus::LD_BGA_CONSISTENCY_FIX
    				|| $bgaType == HdBgaStatus::HD_BGA_MP) 
    	{
    		$notCheckBga = 0;
    	}
    	else 
    	{
    		$notCheckBga = 1;
    	}
    	
    	$now = getNow();
    	$nowTime = strtotime($now);
    	$nowDateStr = date('m/d/Y',$nowTime);
    	$nowTimeStr = date('H:i',$nowTime);
    	$smarty->assign('nowDateStr',$nowDateStr);
    	$smarty->assign('nowTimeStr',$nowTimeStr);
    	
    	$smarty->assign('type',$type);
		$smarty->assign('pageID',$pageID);
		$smarty->assign('jobID',$jobID);
		$smarty->assign('cmdPara',$cmdPara);
		$smarty->assign('VDID',$VDID);
		$smarty->assign('bgaType',$bgaType);
		$smarty->assign('startTime',$startTime);
		$smarty->assign('repeatType',$repeatType);
		$smarty->assign('repeatParam1',$repeatParam1);
		$smarty->assign('repeatParam2',$repeatParam2);
        $smarty->assign('bgaPage',$bgaPage);
        $smarty->assign("CancelAlert",$CancelAlert);
        
        $smarty->assign("notCheckBga",$notCheckBga);
        
		$this->setPageName(Target::NewTimesettingPage . ".tpl");
	}
}
?>